// PROJECT : ALIB
// FILE    : ALBASECL.H - header file for base class
// AUTHOR  : Michael Vorburger, alpha ware, CH-SG
// DATE oC : January 1994
// DATE oLM: October 1994
// LEVEL   : GLE

#ifndef __ALOBJECT_H
#define __ALOBJECT_H


/* ------------------------------------------------------------------------ */

// The contents what is now in ALHND.H was previously part of this file.
// That's why INCLUDing of ALOBJECT includes ALHND. (compatibility).

/* ------------------------------------------------------------------------ */

#include <portab.h>
#include <ids.h>

/* ------------------------------------------------------------------------ */
// AlBObject - BaseObject: Almost everything is derrived from that. It's
// interface has to be kept VERY tiny; things like runtime-type-checking,
// streaming, persistence etc. don't belong in this class!
class AlBObject
{public:
   virtual operator bool() const { return true; }; // is object "valid" or ok?

   virtual ~AlBObject()	         { };
    // Unbedingt so lassen! Durch diesen virtuellen Destruktor erhalten ALLE
    // ALLE abgeleiteten Klassen auch virtuelle Destruktoren. Das ist WICHTIG!
};
class T_ErrBObject : public AlBObject
{ public:                                         // See below.
    operator bool() const { return false; }; };
extern T_ErrBObject ErrBObject;

// AlObject : Classes derrived from this provide runtime-type-checking with
// methods IsA() and TypeOf().
class AlObject : public AlBObject
{
  public:
	virtual BOOL IsA(UWORD id) const = 0;
	virtual UWORD TypeOf() const     = 0;
//  UWORD static typeNrId;
};

class T_ErrObject : public AlObject
{ public:
    BOOL  IsA(UWORD id) const { return(id==IdErrObject); };
    UWORD TypeOf() const      { return IdErrObject;      };
    operator bool() const     { return false;            };
};
extern T_ErrObject ErrObject; // Globales Objekt (zB return ErrObj; bei troubles)

/* ------------------------------------------------------------------------ */

#include <alhnd.h>
// see remark above

/* ------------------------------------------------------------------------ */

/* class isSortable
{ public:
	virtual BOOL IsEqual(const isSortable&) = 0;
	virtual BOOL IsBigger(const isSortable&) = 0;

// ??? - Borlandfehler! Dieses INLINE erzeugt u.U. einen Fehler
// des Linkers (er finde diese Funktion nicht...)
	inline BOOL operator == (const isSortable& c)
	{ return(IsEqual(c)); };

	inline BOOL operator > (const isSortable& c)
	{ return(IsBigger(c)); };

	virtual BOOL IsA(UWORD id) const
		{ return(id==IdisSortable); };
}; */

/* ------------------------------------------------------------------------ */

#endif	// __ALOBJECT_H