// definition of AlObject
// AlObject is the basic class of all alpha-lib derrived classes.

// started : January 1994
// last mod:

// This code makes part of AlLib; level is GLE.
// Michael Vorburger, alpha ware, CH-SG.

#ifndef __ALOBJECT_H
#define __ALOBJECT_H

#include <portab.h>
#include <new.h>

#define DEBUG
#include <alloc.h>
// extern char* classNamesApp[];

#include <ids.h>
// #include <str.h>		// #include <alstring.h>
#include <error.h>

#define NIL     NULL


class AlObject
{
  public:
//	AlObject() { };
    virtual ~AlObject()	{ };
    // Unbedingt lassen! Durch diesen virtuellen Destruktor erhalten ALLE
    // ALLE abgeleiteten Klassen auch virtuelle Destruktoren. Das ist WICHTIG!

	virtual BOOL IsA(UWORD id) const = 0;
	virtual UWORD TypeOf() const = 0;

    virtual operator bool() const { return true; };

//  UWORD static typeNrId;
};

class T_ErrObject : public AlObject
{ public:
    BOOL  IsA(UWORD id) const { return(id==IdErrObject); };
    UWORD TypeOf() const { return IdErrObject; };
    operator bool() const { return false; };
};
// Globales Fehler-Objekt (als Returnwert bei troubles)
extern T_ErrObject ErrObject;

// template<class T>
class debugable /* : virtual public AlObject */
{

#ifdef DEBUG
  private:
	static UWORD nextnumber;
	UWORD number;
  public:
	debugable()
	  { cerr << "CONSTRUCT: new object of class >";
// siehe unten zum folgenden...
/*		if ( TypeOf() < IdAppClassesFirst )
		  { cerr << classNamesAlpha[TypeOf()]; }
		else
		  cerr << classNamesApp[TypeOf()];
*/
		cerr << "< with DebugId #" << (number=nextnumber++)
			 << " (at adr " << this << ")" << endl;
	  };

	virtual ~debugable()
	  {	cerr << "DESTRUCT: object #" << number
			 << " (at adr " << this << ")" << endl;
	  };
/*
	void* operator new(size_t s)
	{
	  void* t;
	  t = ::new char[s];
	  allocatedObjMem += s;
	  if ( t )
		cerr << "NEW: " << s << " bytes allocated on heap (adr " << t << ")" << endl;
	  else
		Error(ErrNoMoMemory);

 	  return t;
	};

	void operator delete(void* p)
	{ if ( heapchecknode(p) != _USEDENTRY )
		{ Error(ErrInDelete); }
	  else
		{ ::delete(p);
		  cerr << "DELETE: " << "heap-block on " << p << " released" << endl; };
	};
*/
  protected:		// derrived classes can access the following...
	static MEMSIZE allocatedObjMem;	  // static means: use like global

#endif
};
// further ideas: Ausgabe von Header mit Name und Startzeit und Endzeile
// 				  mit Stopzeit und Laufzeit. Ausgabe, wenn unvorgesehenes
//				  Ende.
//				  erweiterte Heap-Kontrolle: Wurde alles freigegeben?
//				  (Problem: delete weiss nicht, wie gross ein Block ist...)

//                Ausgabe des tatschlichen VarNamens und des Typ-Namens
//                IST NUR ber Makros zu lsen; siehe DEBUG.CPP

#ifdef DEBUG
class DebugMain
{ ULONG HeapMem;
 public:
  DebugMain();

  ~DebugMain();
};
#endif


template <class T> class Shell;
// class Fruit;

// Fruit nur als "Frucht" fr alShellTempl verwenden!
// ALL Fruit-Objects MUST be dynamic, NOT static!
// NEVER delete an Fruit!
#define isShellable Fruit
class Fruit : /* virtual */ public AlObject
{

// nur Shell darf auf all das untenstehende zugreiffen!
  friend class Shell; // TIP: ohne das "class" hat er Probleme...
// FUNKTIONIERT ABER NICHT! ???

// Zur Vereinfachung das folgende:
#define FRUITMACRO(F) F& Copy() const { return *new F(*this); }; /* \
                      F(const F&); geht leider nicht.
 Die Idee von obigem wre, dass der Programmierer gezwungen wrde,
 IMMER einen Copy-Cstr zu definieren; gibt aber einen Multiple dec. err */

public: //   private: dann halt public
   SWORD refs;		// How many references to this object?
                    // special cases: -1 = dead object, -2 = static object
public:
   virtual ~Fruit()
	 { if ((refs--)>0)
	     Error(ErrWrongDelete);
       refs=-1;                };

   void NY()   		// call this if you point at this object.
	 { if(refs>-1)  // special cases: -1 = dead object, -2 = static object
         refs++;
       else if(refs==-1)
         Error(ErrAccDelObj); };

   void YAF()      // means: YouAreFree. Call this if you don't need the object
	 { if (refs>-2) { // anymore. If nobody wants me, I'll deleted.
         if (refs<1)
	 	   Error(ErrTooManyYAF);
		 else
		   refs--; }; };

  /* Alle Fruits brauchen eine Copy-Funktion. Folgende Deklaration geht mit
     diesem BC3.1 Compiler noch nicht, weil sich der Rckgabetyp hier und
     in der Ableitung unterscheiden. Wird spter erlaubt.
       // virtual Fruit& Copy() const = 0;
     Fr eine Ableitung F muss diese Funktion so definiert werden:
       virtual F& Copy() const { return *new F(*this); };
     Dies setzt gleichzeitig auch einen Copy-Konstruktor voraus.            */

  public:
   Fruit()
	 { refs=0; };
  void MakeStatic() const // { refs=-2; }; geht nicht weil const-member
    { const_cast(Fruit* const, this)->refs=-2; };
/* Erklrung: Fruits MSSEN eigt. immer dynamische Heap-Objekte sein. In
   Ausnahmefllen ist es aber erlaubt, sie statisch zu machen. Dann muss aber
   diese Methode fr das Objekt aufgerufen werden. NY() und YAF() werden dann
   ignoriert.
   Diese Sache ist noch nicht vollstndig & sicher berdacht... ev. mssen
   solcherart Fruits immer const sein??                                     */

/*
   // Error: operator new must return an object of type void *
   // typedef Fruit* newFruit; newFruit operator new(size_t s)
   //  { return (newFruit)( (void*)::new char[s]); };
   void* operator new(size_t s)
     { return ::new char[s]; };
     // welches new aufrufen? alShell? debug?
*/
  protected:
  virtual BOOL IsA(UWORD id) const
	  { return( id == IdFruit ); };
  virtual UWORD TypeOf() const
	  { return IdFruit; };
};

// #define AlShellTempl Shell

/* 1. Die Methode T& MyFrt() sollte ein Err-Objekt zurckliefern knnen.
   Idee: template <class T, T ErrT> und Shell<TermFruit, ErrTerm>
   Das geht leider nicht; obwohl zB template <class T, int sz> erlaubt ist. */
/* 2. Alle abgeleiteten Shell-Klassen S MSSEN folgende Methoden haben:     */
#define SHELL_INTERFACE(S,F) \
        S()                               { }; \
	    S(const S& arg)                   { EqualShell(arg);           }; \
        S(const S* arg)                   { EqualShell(*arg);          }; \
        S(const F& arg)                   { EqualFruitPtr(&arg);       }; \
        S(const F* arg)                   { EqualFruitPtr(arg);        }; \
        Shell<F>& operator=(F& arg)       { return EqualFruitPtr(&arg);}; \
        Shell<F>& operator=(F* arg)       { return EqualFruitPtr(arg); }; \
        Shell<F>& operator=(const F& arg) { return EqualFruitPtr(&arg);}; \
        Shell<F>& operator=(const F* arg) { return EqualFruitPtr(arg); }; \
        Shell<F>& operator=(const S& arg) { return EqualShell(arg);    }; \
        Shell<F>& operator=(const S* arg) { return EqualShell(*arg);   };
/* Dies geht (im Moment nur mit obigem Makro. Folgende Elegante Lsung...
     template<class F, class S> class Shell :
   so dass also zB. eine Klasse Test wie folgt definiert werden knnte
     class Test : public Shell<TestFruit, Test>
   scheitert an einer Fehlermeldung.                                        */

/* Folgendes Makro kann fr jeden Typ, mit dem die Fruit initialisiert
   werden kann, je einmal eingesetzt werden. Siehe String-Klasse.           */
#define FRUITINIT_INTERFACE(S,F,T) \
        S(T init)                  { EqualFruitPtr(new F(init)); }; \
        Shell<F>& operator=(T arg) { return EqualFruitPtr(new F(arg)); };
// Verwenden Sie folgendes Makro fr abgeleitete Klassen F von P:
#define FRUITINIT_INTERFACE_FAM(S,F,P,T) \
        S(T init)                  { EqualFruitPtr(new F(init)); }; \
        Shell<P>& operator=(T arg) { return EqualFruitPtr(new F(arg)); };
// Fr ganz knifflige Situationen hier eine Aufspaltung in Def. & Dek.
#define FRUITINIT_INTERFACE_FAM_DEK(S,F,P,T) \
        S(T init); \
        Shell<P>& operator=(T arg);
#define FRUITINIT_INTERFACE_FAM_DEF(S,F,P,T) \
        S::S(T init)                  { EqualFruitPtr(new F(init)); }; \
        Shell<P>& S::operator=(T arg) { return EqualFruitPtr(new F(arg)); };
#define FRUITINIT_INTERFACE_FAM_INLDEF(S,F,P,T) \
        inline S::S(T init)                  { EqualFruitPtr(new F(init)); }; \
        inline Shell<P>& S::operator=(T arg) { return EqualFruitPtr(new F(arg)); };

template <class T>  // T MUSS eine Fruit sein/enthalten
class Shell // : public AlObject
{ public:
	Shell() : r(NULL) {};
     //{ r=NULL; };

	Shell(const Shell<T>& arg) : r(arg.r) { arg.r->NY(); };
    Shell(const Shell<T>* arg) : r(arg->r) { arg->r->NY(); };
    Shell(const T& arg) : r(const_cast(T*,&arg)) { const_cast(T&,arg).NY(); };
    Shell(const T* arg) : r(const_cast(T*,arg)) { if(arg!=NULL) const_cast(T*,arg)->NY(); };

	/*virtual*/ ~Shell()
     { Liberare(); };

  private: // protected:	// NOT private:
	T* r;

  inline void Liberare()
	  { if (r!=NULL)
		{ r->YAF();
		  if ( (*r).refs==0 )
		    delete r;
		  r=NULL;
		};
	  };

  // r und Liberare() mssen private sein. Die Shell-Klassen kommunizieren
  // mit dem Shell Kern ber untenstehende Funktionen.

  public: // protected:
    Shell<T>& EqualFruitPtr(const T* arg)
    { if (arg!=r) {
        if (arg!=NULL)
          const_cast(T*,arg)->NY();
        Liberare();
        r=const_cast(T*,arg);
      };
      return *this;
    };
    #define EqualFrtPtr EqualFruitPtr

    Shell<T>& EqualShell(const Shell& arg)
	{ if(arg.r!=r) {
        arg.r->NY();
	    Liberare();
	    r=arg.r;
      };
	  return *this;
	};

#pragma warn -inl
    const T& MyFrtConst() const
    { if (r!=NULL)
		return *r;
	  else
		{ Error(ErrNotInitVar); /* return ErrT; s.o. */ };
	};

    T& MyFrtMustCopy() const
    { if (r!=NULL)
          return r->Copy();
          // FALSCH wre: *new T(*r); weil so Probleme mit verberbten T's
	  else
		{ Error(ErrNotInitVar); /* return ErrT; s.o. */ };
	};

    T& MyFrtCopy() const
    { if (r!=NULL)
		if(r->refs>1)
          return r->Copy(); // so.
        else
          return *r;
	  else
		{ Error(ErrNotInitVar); /* return ErrT; s.o. */ };
	};
//#pragma warn +inl

    T& MyFrt() 
      { return MyFrtCopy(); };
    const T& MyFrt() const
      { return MyFrtConst(); };

    T& FrtChange()
      { T& newFrt=MyFrtCopy();
        EqualFrtPtr(&newFrt);
        return newFrt;        };

public:
    const T& operator() () const
      { return MyFrtConst(); };

//	T& operator() () const       BC 3.1 bringt MULTIPLE DECLARATIOIN
//      { return MyFrtCopy(); };

    const T* operator-> () const
      { return &MyFrtConst(); };

//    T* operator-> () const
//      { return &MyFrtCopy(); };

// cast-Operator geht nicht immer; Compiler muss WISSEN, welcher Typ bentigt
// Bsp. Geg. F f; S<F> s; class F has method m(); void func(const F& a)
// f.m() [ok]; s.m() [no!]; func(f) [ok]; func(s) [ok];
	operator const T&() const
      { return MyFrtConst(); };

	operator T&() const
      { return MyFrtCopy(); };

    void Reset() { Liberare(); };
    operator bool() const
      { if (r!=NULL)
          return MyFrtConst();
        else
          return false;  };
/*
	virtual BOOL IsA(UWORD id) const
	{ return( id == IdShell
//                 || T::IsA(id)   Nicht machen! Eine Shell ist KEINE Fruit.
                             ); };

	virtual UWORD TypeOf() const
	  { return IdShell; };
*/
};
// typedef Shell Hnd;
#define Hnd Shell

class isSortable
{ public:
	virtual BOOL IsEqual(const isSortable&) = 0;
	virtual BOOL IsBigger(const isSortable&) = 0;

// ??? - Borlandfehler! Dieses INLINE erzeugt u.U. einen Fehler
// des Linkers (er finde diese Funktion nicht...)
	inline BOOL operator == (const isSortable& c)
	{ return(IsEqual(c)); };

	inline BOOL operator > (const isSortable& c)
	{ return(IsBigger(c)); };

	virtual BOOL IsA(UWORD id) const
		{ return(id==IdisSortable); };
};

#endif	// __ALOBJECT_H