#define DERR_SHELL_INTERFACE_CSTR(S,P,F) \
        S()                        : P()    { }; \
        S(const F& arg)            : P(arg) { }; \
        S(const Shell<F>& arg)     : P(arg) { }; //\
//        S(const F* arg)            : P(arg) { }; \
//        S(const Shell<F>* arg)     : P(arg) { }; \

#define DERR_SHELL_INTERFACE_ASSG(F) \
        Shell<F>& operator=(const F& arg) { return EqualFrtPtr(&arg); }; \
        Shell<F>& operator=(const Shell<F>& arg) { return EqualShell(arg); }; //\
//        Shell<F>& operator=(const ShellEngine& S)  { return EqualShell(S); };
//        Shell<F>& operator=(const F* arg) { return EqualFruitPtr(arg);  }; \
//        Shell<F>& operator=(const Shell<F>* arg) { return EqualShell(*arg);    }; //\

#define DERR_SHELL_INTERFACE(S,P,F) DERR_SHELL_INTERFACE_CSTR(S,P,F) \
                                    DERR_SHELL_INTERFACE_ASSG(F)

#define SHELL_INTERFACE(S,F) DERR_SHELL_INTERFACE(S,Shell<F>,F)
/*      S()                               { }; \
        S(const F* arg)                   : Shell<F>(arg)                 { }; \
        S(const F& arg)                   : Shell<F>(arg)                 { }; \
        S(const Shell<F>& arg)            : Shell<F>(arg)                 { }; \
        S(const Shell<F>* arg)            : Shell<F>(arg)                 { }; \
        Shell<F>& operator=(const F& arg) { return EqualFruitPtr(&arg);     }; \
        Shell<F>& operator=(const F* arg) { return EqualFruitPtr(arg);      }; \
        Shell<F>& operator=(const Shell<F>& arg) { return EqualShell(arg);  }; \
        Shell<F>& operator=(const Shell<F>* arg) { return EqualShell(*arg); }; //\
*/

/*      Shell<F>& operator=(F& arg)       { return EqualFruitPtr(&arg);     }; \
        Shell<F>& operator=(F* arg)       { return EqualFruitPtr(arg);      }; \ */
// Obige Makros braucht es, weil Konstruktoren und operator= nicht "richtig"
// vererbt werden.
    //#if (sizeof(S)!=sizeof(Shell<F>)) \
    //  #error Uops! Your handle has additional data members or virtual members \
    //#endif

// FRUIT_INTERFACE(self.Typ, FruitTyp, InitializerTyp) bel. viele Male. Die
// Shell kann dann mit InitializerTyp initialisiert werden. Achtung: Die
// Entsprechende Fruit braucht einen Konstruktor UND EINEN operator=() [!!]
// mit Arg InitTyp.
#define DERRSHELL_FRUITINIT_INTERFACE_FAM(S,SP,F,FP,T) \
        S(const T  init)                   : SP( *new F(init)  )       {  }; \
        Shell<FP>& operator=(const T  arg) { return EqualFrtPtr(new F(arg)); }; //\
//        S(const T* init)                   : SP( new F(*init)  )      {  }; \
//        Shell<FP>& operator=(const T* arg) { return EqualFruitPtr(new F(*arg));};

#define FRUITINIT_INTERFACE_FAM(S,F,FP,T) \
        DERRSHELL_FRUITINIT_INTERFACE_FAM(S,Shell<FP>,F,FP,T)
/*      S(const T  init)                  { EqualFruitPtr(new F(init)); }; \
        S(const T* init)                  { EqualFruitPtr(new F(*init));}; \
        Shell<P>& operator=(const T  arg) { return EqualFruitPtr(new F(arg)); }; \
        Shell<P>& operator=(const T* arg) { return EqualFruitPtr(new F(*arg));};
*/
#define DERRSHELL_FRUITINIT_INTERFACE(S,SP,F,T) \
        DERRSHELL_FRUITINIT_INTERFACE_FAM(S,SP,F,F,T)

#define FRUITINIT_INTERFACE(S,F,T) \
        FRUITINIT_INTERFACE_FAM(S,F,F,T)
/*        S(const T init)                   : Shell<F>( new F(init)  )       {  }; \
        Shell<F>& operator=(const T arg)  { return EqualFruitPtr(new F(arg)); }; //\
/*      S(const T* init)                  : Shell<F>( new F(*init) )       {  }; \
        Shell<F>& operator=(const T* arg) { return EqualFruitPtr(new F(*arg));};
*/*/
// Fr ganz knifflige Situationen hier eine Aufspaltung in Def. & Dek.
/*
#define FRUITINIT_INTERFACE_FAM_DEC(S,F,P,T) \
        S(const T  init); \
        S(const T* init); \
        Shell<P>& operator=(const T  arg); \
        Shell<P>& operator=(const T* arg);
#define FRUITINIT_INTERFACE_FAM_DEF(S,F,P,T) \
        S::S(const T  init)                  { EqualFruitPtr(new F(init)); }; \
        S::S(const T* init)                  { EqualFruitPtr(new F(*init));}; \
        inline Shell<P>& S::operator=(const T  arg) { return EqualFruitPtr(new F(arg)); }; \
        inline Shell<P>& S::operator=(const T* arg) { return EqualFruitPtr(new F(*arg));};
*/



template <class T>  // T must "be" a Fruit (publicly derrived from it)
class Shell
{ public:
    void Reset() { Liberare(); };

    operator bool() const
      { if (r!=NULL)
          return MyFrtConst();
        else
          return false;  };

    bool operator==(const Shell<T>& c) const
      { if(r==c.r)
           return true;
        else
           return( *r==*c.r );  };

	Shell()                    : r(NULL)                {                          };
	Shell(const Shell<T>& arg) : r(arg.r)               { arg.r->NY();             };
    Shell(const Shell<T>* arg) : r(arg->r)              { arg->r->NY();            };
    Shell(const T& arg)        : r(const_cast(T*,&arg)) { arg.NY();                };
    Shell(const T* arg)        : r(const_cast(T*,arg))  { if(arg!=NULL) arg->NY(); };


// ATTENTION: The following assingment operators have to be defined here (in
// this class) because one might use type Shell<Fruit> directly -without
// derriving from it- AND ALSO in the derrived class (see macro SHELL_INTERFACE)
   DERR_SHELL_INTERFACE_ASSG(T)
/*
        typedef T F;
 //       Shell<F>& operator=(F& arg)       { return EqualFruitPtr(&arg);     }; \
//        Shell<F>& operator=(F* arg)       { return EqualFruitPtr(arg);      }; \
        Shell<F>& operator=(const F& arg) { return EqualFruitPtr(&arg);     }; \
        Shell<F>& operator=(const F* arg) { return EqualFruitPtr(arg);      }; \
        Shell<F>& operator=(const Shell<F>& arg) { return EqualShell(arg);  }; \
        Shell<F>& operator=(const Shell<F>* arg) { return EqualShell(*arg); }; //\
*/
	~Shell() { Liberare(); }; // no virtual please. saves memory.

  protected:
    T& Frt()                { return FrtUpd();   };
    const T& Frt()  const   { return FrtConst(); };

// the following for backward compatibility, use the substitutes
    const T& MyFrtConst() const { return Frt(); };
    //T& MyFrtMustCopy() const    { return *new(T(Frt())); };

    Shell<T>& EqualFruitPtr(const T* arg)
    { if (arg!=r) {
        if (arg!=NULL)
          const_cast(T*,arg)->NY();
        Liberare();
        r=const_cast(T*,arg);
      };
      return *this;                                                  };
    Shell<T>& EqualFrtPtr(const T* arg) { return EqualFruitPtr(arg); };

    Shell<T>& EqualShell(const Shell& arg)
	{ if(arg.r!=r) {
        arg.r->NY();
	    Liberare();
	    r=arg.r;
      };
	  return *this;	                                                 };

private://protected: //
    const T& FrtConst() const //MyFrtConst
    { if (r==NULL)
		{ Error(ErrNotInitVar); /* return ErrT; s.u. */ };
	  // else
		return *r;	};
    //const T& FrtConst() const { return MyFrtConst(); };

    T& FrtUpd()
      { T& newFrt=MyFrtCopy();
        EqualFrtPtr(&newFrt);
        return newFrt;        };

    T& MyFrtCopy() const
    { if (r==NULL)
		{ Error(ErrNotInitVar); /* return ErrT; s.u. */ };
      // else {
		if(r->refs>1 || r->refs==-2)
          return ref_cast(T,r->Copy()); // so.
        else
          return *r; /* }; */                                        };
    T& FrtCpy() const { return MyFrtCopy(); };

    T& FrtMustCpy() const // MyFrtMustCopy
    { if (r==NULL)
		{ Error(ErrNotInitVar); /* return ErrT; s.u. */ };
	  //else
          return ref_cast(T,r->Copy());
          // FALSCH wre: *new T(*r); weil so Probleme mit verberbten T's
          // ref_cast wg. prob bei ndern von Copy() return type (so.)
	};
    //T& FrtMustCpy() const { return MyFrtMustCopy(); };

 protected:
/*	virtual BOOL IsA(UWORD id) const
	{ return( id == IdShell
//                 || T::IsA(id)   Nicht machen! Eine Shell ist KEINE Fruit.
                             ); };

	virtual UWORD TypeOf() const
	  { return IdShell; };        */

 private: // Derrived classes use only protected members above to access.
   T* r;

   inline void Liberare()
	  { if (r!=NULL)
		{ r->YAF();
		  if ( (*r).refs==0 )
		    delete r;
		  r=NULL;             };
	  };
};
