
#include <alobject.h>
#include <list.h>

// look at also in LISTTST2.CPP

class MyList1 : public ListBase<char>, public isASCIIable
{ public:
    String AsASCII() const
     { char* s=new char[Size()+1];
       for(UWORD i=1; i<=Size(); i++)
         s[i-1]=operator[] (i);
       s[Size()]=0;
       String r=s;
       delete[] s;
       return r;
     };
};


void Demo1()
{
  MyList1 List1;

  List1.Append('A');
  List1.Append('B');
  List1.Append('C');
  cout << List1 << endl;   // ABC

  List1.Insert(2,'x');
  cout << List1 << endl;   // AxBC

  List1.Remove(2);
  cout << List1 << endl;   // ABC

  List1.Remove(1);
  cout << List1 << endl;   // BC
};

class MyList2 : public ListBase<String>, public isASCIIable
{ public:
    String AsASCII() const
     { String t("");
/* IMPORTANT: String t; IS WRONG!
    This lib makes a difference between UNINITIALIZED and EMPTY variables.
    If you define String t it is UNINITIALIZED and nothing can be added +=
    The right way to do what you want is to define a String t("").        */
       for(UWORD i=1; i<=Size(); i++)
         t+=operator[] (i) + ", ";
       return t;
     };
};

void Demo2()
{
   MyList2 List2;
/*
   List2.Append(*new String("Eins"));
   List2+=*new String("Zwei");         // NOT +="Eins" !
*/
   String s1("Eins");
   String s2("Zwei");
   String s3("Drei");
   String s4("Vier");

   List2+=s1;
   List2+=s1; // s2
   List2+=s3;
// cout << List2[1] << endl;
   cout << List2 << endl;   // Eins, Zwei, Drei

   List2.Remove(2);
   cout << List2 << endl;   // Eins, Drei

   List2.Append(s4);
   List2.Insert(3,s1);
   cout << List2 << endl;   // Eins, Drei, Eins, Vier

   MyList2 List3(List2);
   cout << List3 << endl;
   List3.Remove(1);
   cout << List3 << endl;
   cout << List2 << endl;
   List3[1]="Neu Drei";
   cout << List3 << endl;
   cout << List2 << endl;
   cout << s3 << endl;

   MyList2 List4;
   cout << List4 << endl;
   List4=List3;
   cout << List4 << endl;
};

void Demo3()
{
  String* StrArr;
  StrArr=new String[2];

  StrArr[0]="Null";
  StrArr[1]="Eins";

  // see what happens if you use delete instead of delete[] !
  delete[] StrArr;
};

/* DEMO4: Rckgabe von lokalen Shell-Variabeln erlaubt. */

String Test() {
  String t("Mike");
  return t;   };

void Demo4()
{ String s;
  s=Test();
  cout << s; };

/* --------------------------------------------------- */

void Demo5()
{
  String s1("A-Eins");
  String s2("B-Zwei");
  String s3("C-Drei");
  String s4("D-Vier");
  MyList2 List;

  List.Append(s1); List.Append(s2); // List.Append(s4);
  cout << List << endl;

  LIter<String> I(List);
/*bool b1,b2;
  String s;
  do {
    s=List[I];
    b1=s3>s;
    cout << s3 << ">" << s << "=" << b1 << endl;
    b2=I.Valid();
    ++I;
  } while (b1 && b2);
*/
  while(I.Valid())
    if(s4>List[I])  // muss so gemacht werden, weil List[I] sonst abbricht.
      ++I;
  if(I)
    List.Insert(I,s4);
  else
    List.Append(s4);

  cout << List << endl;
};


void main()
{
  Demo5();
};
