Diese List-Version funktioniert soweit, hat aber eine grundlegenden Designfehler.
Der Zugriff auf OrdCollection und OIter ist Inkonsistent. Machen wirs ber 
UWORD (dh. 1..MaxItem) oder SWORD (dh. LBound..UBound)
Nach einigem Hin- und Her und wieder ndern und doch nicht habe ich mich zu
folgender Lsung entschlossen: OrdCollection sind geordnet und haben ein erstes
bis ein MaxItem()'s Element. Listen, Arrays, Dics etc. funktionieren so. Es ist
nicht erlaubte, irgendeine Art von Liste/Array o. von OrdCollection abzuleiten,
die Grenzen zB. von -5 bis 3 erlaubt. Die Indizes gehen IMMER von 1..n!

// typedef enum {false, true} bool; //
#include <portab.h>
#include <error.h>
#include <alstring.h>

/* ------------------------------------------------------------------------ */
// FORWARD-Deklarationen
template<class I, class O> class Iter;
template<class T> class ArrayIntf;
template<class T> class AIterIntf;
template<class I, class O> class OIter;

/* ------------------------------------------------------------------------ */
// Container<I, O> & Iter<I, O> - abstract base class for EVERYTHING

template<class I, class O> class Container
{ public:
   virtual void      Add(const I&)                   = 0;
   virtual O&        Get() = 0;
   virtual ~Container() {};

   Container& operator+=(const I& e)              { Add(e); return *this; };
   Container& operator<<(const I& e)              { Add(e); return *this; };
};


template<class I, class O> class Collection : public Container<I,O>
{ public:
   virtual Iter<I, O>& Find(const I&) const          = 0;
   virtual void      Remove(const Iter<I, O>&)       = 0;
   virtual O&        Get(Iter<I, O>& i)              = 0;
   virtual const O&  Get(const Iter<I, O>& i) const  = 0;
   // virtual Iter<I, O>& NewIter() const              = 0;

   O&       operator[](Iter<I, O>& i)             { return Get(i);        };
   const O& operator[](const Iter<I, O>& i) const { return Get(i);        };

  friend class Iter<I, O>;
};

template<class I, class O> class Iter
{ public:
    virtual bool Valid() const                            = 0;
    virtual bool ValidFor(const Collection<I, O>& c) const = 0;
    virtual const O& Get() const                          = 0;
    virtual       O& Get()                                = 0;

    operator bool()                      { return Valid(); };
    virtual const O& operator() () const { return Get();   };
    virtual O& operator() ()             { return Get();   };

    Iter() {};
};

/* ------------------------------------------------------------------------ */
// Set<T>
// A Set is an unordered set (:-) of items; so you cannot iterate through it!
template<class T> class Set : public Collection<T, T>
{ public:
};

/* ------------------------------------------------------------------------ */
// Stack<T>
// A Stack is a stack. If you don't know what this is -> :-(

template<class T> class Stack : public Container<T, T>
{ public:
};

/* ------------------------------------------------------------------------ */
// Queue<T>
template<class T> class Queue : public Container<T, T>
{ public:
};

/* ------------------------------------------------------------------------ */
// OrdCollection<I, O> & OIter<I, O> - abstract base class
// An OrdCollection is an ordered thing: You can access the "third" item and
// you can iterate (by using SWORDs or OrdIters) through it.
template<class I, class O> class OrdCollection : public Collection<I, O>
{ public:
   virtual OIter<I, O>& NewOIter() const = 0; // { return (OIter<I, O>&)NewIter(); }; // TC!

   virtual O&        Get(const SWORD)          = 0;
   virtual const O&  Get(const SWORD) const    = 0;
   virtual UWORD     Items() const             = 0;
   virtual O&        Get() { return Get( Items() ); };
     // inherited from Container. This is a default solution.

   virtual O&        Get(Iter<I, O>& i)             { return i.Get(); };
   virtual const O&  Get(const Iter<I, O>& i) const { return i.Get(); };
   O&       operator[](Iter<I, O>& i)               { return Get(i);  };
   const O& operator[](const Iter<I, O>& i) const   { return Get(i);  };
   const O& operator[](SWORD i) const               { return Get(i);  };
   O& operator[](SWORD i)                           { return Get(i);  };
};

//enum OIterSetArg { FIRST, MIDDLE, LAST };
template<class I, class O> class OIter : public Iter<I, O>
{ public:
    OIter() {};
    virtual OIter& operator++ () = 0;
    //void operator++ (int);
    virtual OIter& operator-- () = 0;
    //void operator-- (int);
    virtual void   Set(SWORD p)  = 0;
};

/* ------------------------------------------------------------------------ */
// Array<T> & AIter<T>
// An Array behaves like a built-in array: It's size is fixed.

template<class T> class ArrayIntf : public OrdCollection<T,T>
{ public:
   //ArrayIntf(SWORD a, SWORD e=0);
   //virtual ~ArrayIntf();

   virtual UWORD     Items() const              = 0;
   virtual SWORD     LowerBnd() const           = 0;
   virtual SWORD     UpperBnd() const           = 0;

   virtual void      Add(const T& i)            = 0;
   virtual AIterIntf<T>& Find_AIter(const T&) const = 0;
           Iter<T,T>& Find(const T& i) const { return (Iter<T,T>&)Find_AIter(i); }; // TC
   //virtual T&        Get(itnAIter& p)              { return p.Get(); };
   //virtual const T&  Get(const itnAIter& p) const  { return p.Get(); };
   virtual T&        Get(const SWORD i)         = 0;
   virtual const T&  Get(const SWORD i) const   = 0;
   virtual void      Remove(const Iter<T,T>&)   = 0;
           OIter<T,T>& NewOIter() const         = 0;

  ArrayIntf() {};
  friend class AIterIntf<T>;
};

template<class T> class AIterIntf : public OIter<T,T>
{ public:
    //AIterIntf(const ArrayIntf<T>& c)              = 0;
    //AIterIntf(const ArrayIntf<T>& c, SWORD p)     = 0;
    //AIterIntf& operator=(const AIterIntf& s)      = 0;
    bool Valid() const                            = 0;
    bool ValidFor(const Collection<T, T>& c) const = 0;

    const T& Get() const                          = 0;
    T& Get()                                      = 0;

    OIter<T,T>& operator++ ()                     = 0;
    OIter<T,T>& operator-- ()                     = 0;
    void Set(SWORD p)                             = 0;

    AIterIntf() {};
    friend class ArrayIntf<T>;
};

template<class T> class ArrayImpl1 : public ArrayIntf<T>
{ public:
   ArrayImpl1(SWORD a, SWORD e=0);
   virtual ~ArrayImpl1() { delete[] arr; };

   UWORD     Items() const                 { return l-f+1; };
   SWORD     LowerBnd() const              { return f; };
   SWORD     UpperBnd() const              { return l; };

   void      Add(const T& i);
   AIterImpl1<T>& Find_AIterImpl1(const T&) const;
    AIterIntf<T>& Find_AIter(const T& i) const { return (AIterIntf<T>&)Find_AIterImpl1(i); }; // TC
   //Iter<T,T>& Find(const T& i) const { return (Iter<T,T>&)Find_AIter(i); }; // TC
   //T&        Get(Iter<T,T>& p)             { return p.Get(); };
   //const T&  Get(const Iter<T,T>& p) const { return p.Get(); };
   T&        Get(const SWORD i)            { CheckBnd(i); return arr[i-f]; };
   const T&  Get(const SWORD i) const      { CheckBnd(i); return arr[i-f]; };
   void      Remove(const Iter<T,T>&);
   OIter<T,T>& NewOIter() const { return *new AIterImpl1<T>(*this); };

  protected:
    SWORD f, l; // first & last
    SWORD n;    // next item position for a new item
    T*    arr;  // ptr to real C-array
    void CheckBnd(SWORD j) const { if((j<f) || (j>l) || (j>n-1) ) Error(ErrArrayBounds); };
  friend class AIterImpl1<T>;
};
#define Array ArrayImpl1 // typedef doesn't work with templates

template<class T> class AIterImpl1 : public AIterIntf<T>
{   void Checki() const { if (!Valid()) Error(ErrArrayBounds); };
  public:
    AIterImpl1(const Array<T>& c)          : C(c) { i=0; };
    AIterImpl1(const Array<T>& c, SWORD p) : C(c) { C.CheckBnd(p); i=p-C.f; };
    AIterImpl1& operator=(const AIterImpl1& s)    { ValidFor(s.C); i=s.i; };

    bool Valid() const                            { return (i<(C.l-C.f) /*&& i<(C.n-C.f)*/ ); };
    bool ValidFor(const Collection<T, T>& c) const
      { if(&C!=&c) Error(ErrWrongIter); /*else*/ return true; };

    const T& Get() const      { Checki(); return C.arr[i]; };
    T& Get()                  { Checki(); return C.arr[i]; };

    OIter<T,T>& operator++ () { Checki(); ; i++; return *this; };
    OIter<T,T>& operator-- () { Checki(); ; i--; return *this; };
    void Set(SWORD p)         { C.CheckBnd(p); i=p-C.f;        };
  protected:
    const Array<T>& C;
    UWORD i;                  // currently "iterated" item
  friend class ArrayImpl1<T>;
};
#define AIter AIterImpl1 // typedef doesn't work with templates

/*
template<class T> class ArrayImpl2 : public ArrayImpl1<T>
{ public:                          /* (j>(l-f)) */
   ArrayImpl2(SWORD a, SWORD e=0) : ArrayImpl1<T>(a,e) { };
   // virtual ~ArrayImpl2() { delete[] arr; };

   void      Add(const T& i);
   //AIterImpl1<T>& Find_AIterImpl1(const T&) const;
   // AIterIntf<T>& Find_AIter(const T& i) const { return (AIterIntf<T>&)Find_AIterImpl1(i); }; // TC
   //T&        Get(const SWORD i)            { CheckBnd(i); return arr[i-f]; };
   //const T&  Get(const SWORD i) const      { CheckBnd(i); return arr[i-f]; };
   void      Remove(const Iter<T,T>&);
   OIter<T,T>& NewOIter() const { return *new AIterImpl1<T>(*this); };

  protected:
    SWORD f, l; // first & last
    SWORD n;    // next item position for a new item
    T*    arr;  // ptr to real C-array

  friend class AIterImpl1<T>;
}; */

/* ------------------------------------------------------------------------ */
// List<T> & LIter<T>
// Lists are similar to Arrays, but they are "unlimited"
template<class T> class List : public OrdCollection<T, T>
{ public:

};

/* ------------------------------------------------------------------------ */
// SortList<T> & sLIter<T>
// SortLists are similar to Lists, but all elements are automatically sorted
// Take care: You have no idea & control at which position an item is stored;
// but SortLists still are OrdCollections because you can iterate through them.
template<class T> class SortList : public OrdCollection<T, T>
{ public:
};

/* ------------------------------------------------------------------------ */
// Dictionary<K,V> & DIter<V>
// A dictionary contains two lists: One for storing a _Key and another for a
// _Value. You have to use Add(K,V) to add a pair of a key and a value which
// you will be able to access later by using Find(K) with a key. Find() will
// return an Iter; use it to get back the Value with V Get(Iter).
template<class K, class V> class Dictionary : public OrdCollection<K, V>
{ public:
    void      Add(const K&, const &V);
    Iter<K,V> Find(const I&) const;
    V&        Get(const Iter<K, V>&);
    const V&  Get(const Iter<K, V>&) const;
    void      Remove(const Iter<L, V>&);

    void Add(const K&); // NOT defined! If used anyway, the linker detects it.
};

/* ------------------------------------------------------------------------ */
// ContUWI<ItemT,CollectionT> - CollectionUserWorldInterface
// Derrive any Collection class from ContUWI and it can be outputet to cout!
/*
template<class T> class ContUWI : virtual public OrdCollection<T,T,SWORD>, public isASCIIable {
  String AsASCII() const
   { OIter<T,T,SWORD>& I=NewIter_OIter();
     String s("{");
     while(I)
       { s+=I(); I++; };
     s+="}";
     return s;             };
};
Das funktioniert aus div. Grnden (im Moment?) nicht wie gedacht...
*/

/* ------------------------------------------------------------------------ */
//                            IMPLEMENTATION
/* ------------------------------------------------------------------------ */

template<class T> ArrayImpl1<T>::
Array(SWORD a, SWORD e=0) {
  if((a<e) && (e!=0))
    { f=a; l=e; }
  else if(a>0 && e==0)
    { f=0; l=a; }
  else
    Error(ErrArrayBounds);

  arr=new T[l-f+1];
  n=f;
};

template<class T> inline void ArrayImpl1<T>::
Add(const T& i)
  { if(n>l) Error(ErrArrayOverflow);
    else arr[(n++)-f]=i;             };

template<class T> AIterImpl1<T>& ArrayImpl1<T>::
Find_AIterImpl1(const T& c) const
  { for(UWORD q=0; q<(l-f+1); q++)
      if(arr[q]==c)
        return *new AIterImpl1<T>(*this,q+f);
    return *new AIterImpl1<T>(*this,l+1);
  };

template<class T> void ArrayImpl1<T>::
Remove(const Iter<T,T>& I)
  { I.ValidFor(*this); I.Valid();                // Wenn I ValidFor dieses Array
    for(UWORD q=TC(I,AIterImpl1<T>&).i; q<(l-f); q++) // ist, ist es sicher ein AIterImpl1.
      arr[q]=arr[q+1];
    n--;
  };
