#include <alobject.h>
#include <list_tpl.h>

typedef ContainerABC<ShellEngine,ShellEngine> ContainerHnd_ABC;
typedef ContainerABC<char,char>               ContainerChar_ABC;

template<class I, class O> class Container : public Hnd<ContainerHnd_ABC>
{ public:
   /*virtual*/ void        Add(const I& a)    { Frt().Add(a); };
   /*virtual*/ O           GetRemove()        { return Frt().GetRemove(); };
   /*virtual*/ const bool  IsEmpty() const    { return Frt().IsEmpty(); };
//   /*virtual*/             ~ContainerABC()    { };

   Container& operator+=(const I& e)   { Add(e); return *this; };
   Container& operator<<(const I& e)   { Add(e); return *this; };
   O          operator() ()            { return GetRemove();   };
              operator const bool()    { return !IsEmpty();    };

   SHELL_INTERFACE(Container,ContainerHnd_ABC)

  //Container() { };
};

template<class T> class Stack_ABC : public ContainerABC<T, T>
{ public:
   void       Add(const T& a) = 0;
   T          GetRemove()     = 0;
   const bool IsEmpty() const = 0;
};

template<class T> class Stack_Ill : public Stack_ABC<T>
{ public:
   void       Add(const T& a);
   T          GetRemove();
   const bool IsEmpty() const  { return last==NIL; };

   Stack_Ill() : last(0), head(0)  { };
   ~Stack_Ill();

  private:
    Node<T>* last;
    Node<T>* head;
};
#define Stack Stack_Ill
