// #include <alobject.h>
//#include <alstring.h>
#include <portab.h>
//#include <error.h>

/* ------------------------------------------------------------------------ */
// ListTpl<T>
// Diese Template-Klasse ist eine sehr allgemeine Liste, die Elemente vom
// Typ T ablegt. Diese werden IMMER direkt, also nicht als Referenzen oder
// Pointer behandelt! Also als Typ von T entweder int/char etc. oder Ptr
// oder Ref oder SHELLs verwenden.
// DIESE KLASSE WIRD IM NORMALFALL NICHT VOM ANWENDER VERWENDET. Dazu steht
// List<T> zur Verfgung.

template<class T> class ListTpl // : public AlObject //, public debugable
{ protected:
    UWORD size; // Anzahl Elemente des dyn. Arrays
	UWORD incr; // um wieviel Elemente wird size bei Bedarf erhht?
	UWORD next; // nchste Schreibposition (letztes Elem+1) im dyn. Array
    T* pMemArr; // Ptr auf Array mit size-Elementen

  public:
	ListTpl(UWORD startSize, UWORD increase);
    ListTpl(const ListTpl& copyL);
    ListTpl& operator= (const ListTpl& copyL);
	~ListTpl();

    void      Append(const T&);
    void      Insert(UWORD, const T&);
    void      Remove(UWORD);
//    void      Insert(Iter<T> p, const T& e) { p.ValidFor(*this); Insert(p.i, e); };
//    void      Remove(Iter<T> p)             { p.ValidFor(*this); Remove(p.i);    };
//    ListTpl& operator+=(T& a)	              { Append(a); return *this;           };

#pragma warn -inl
    T& operator[] (UWORD p) /*const*/       // [] gibt das x. Element zurck
       { if ( ( (p-1)<next) && p>0 )        // Zhlung ab 1 !!
           return pMemArr[p-1];
         else
           Error(ErrOORinLA); };
//#pragma warn +inl
//    T& operator[] (Iter<T> p) /*const*/     { p.ValidFor(*this); return operator[] (p.i); };
/* Zur Auskommentierung von const: Obige beiden Methoden geben eine Refernz auf
   ein internes Objekt zurck und sind damit nicht wirklick const, weil sie
   dadurch indirekt gendert werden knnen, auch wenn sie selbst nichts
   verndern.                                                                  */
    UWORD     Size() const                  { return next;                      };

//  BOOL IsA(UWORD id) const { return id==IdList; };
// 	UWORD TypeOf() const     { return IdList; };
};

/* ------------------------------------------------------------------------ */
// ListVoid
//typedef ListTpl<void*> ListVoid;

/* ------------------------------------------------------------------------ */
// ListBase<T>
// Eine ListBase ist die Vaterklasse aller Listen, Mengen etc.
// Sie enthlt ein dyn. Array von Elementen und ist nur fr elementare Typen
// mit trivialer oder automatischer Speicherverwaltung geeignet, da Elemente
// unter Umstnden umkopiert werden. Unbedingt mglichst kleine Typen whlen.
// ACHTUNG: Nie Listen von Zeigern verwenden; dazu sind Shells zu verwenden!

/* Folgende Methoden stehen ALLEN Listen, Mengen etc. offen:
     - Size()            gibt die Anzahl der Elemente zurck
     - Remove(Iter)      entfernt ein best. Element
     - T& operator[Iter] gibt ein best. Element zurck                      */

template<class T> class ListBase : private ListTpl<T> // ListVoid
{ public:
#pragma warn -obi
	ListBase(UWORD size = 10, UWORD inc = 5) : (size, inc) { }; // sorry for style, but BC3.1
    ListBase(const ListBase& copyL)          : (copyL)     { }; // errors with : ListVoid(copyL);
    ListBase& operator= (const ListBase& c)
      { ListTpl<T>::operator=(c); return *this;      };
   // { return (ListBase<T>&)ListVoid::operator=(c); };

    UWORD Size() const       { return /*ListVoid*/ListTpl<T>::Size();      };
    void Remove(Iter<T> p)   { p.ValidFor(*this); ListTpl<T>::Remove(p.i); };
    T& operator[] (Iter<T> p)
      { p.ValidFor(*this); return ListTpl<T>::operator[] (p.i);            };
   // { p.ValidFor(*this); return *(T*)ListVoid::operator[] (p.i);         };

 protected:
   void Append(const T& e)          { ListTpl<T>::Append(e);               };
   void Insert(UWORD p, const T& e) { ListTpl<T>::Insert(p,e);             };
   void Remove(UWORD p)             { ListTpl<T>::Remove(p);               };
   T& operator[] (UWORD p)          { return ListTpl<T>::operator[] (p);   };
/* void Append(const T& e)          { ListVoid::Append((void*)&e);         };
   void Insert(UWORD p, const T& e) { ListVoid::Insert(p,(void*)&e);       };
   void Remove(UWORD p)             { ListVoid::Remove(p);                 };
   T& operator[] (UWORD p)          { return *(T*)ListVoid::operator[] (p);};
*/ };

//template<class T> class List : public ListBase<T>;
//template<class T> class SortBase : public ListBase<T>;
template<class T> class SortList;

/* ------------------------------------------------------------------------
// Iterator<T>
   Mit einem Iterator kann auf Liste/Menge etc. vom Typ T zugegriffen werden.
   Er ersetzt bzw. erweitert die Mglichkeiten des alten Integer-Indizes.
   Ein Iterator ist Listenspezifisch (nicht austauschbar) und kann seine
   ev. Gltigkeit verlieren; siehe SetBase.                                 */

enum LIterSetArg { FIRST, MIDDLE, LAST };
enum LIterIncArg { HALF };

template<class T> class Iter {
 protected:
  const ListBase<T>& L;
 public: // eigt. auch protected, klappt aber mit friends nicht so ganz!
  UWORD     i;         // Index im Format 1..N nicht 0..N; 0 heisst ungltig.
 public:
  Iter(const ListBase<T>& l) : L(l), i(1) { if(L.Size()==0) i=0; };
  bool Valid()                            { return (( i<=L.Size()) && i>0); };
  bool ValidFor(const ListBase<T>& c)
    { if(&L!=&c) Error(ErrWrongIter); /*else*/ return (&L==&c);            };
  operator bool()                       { return Valid();                  };
  void operator++ ()                    { i++;  if (!Valid()) i=0;         };
  void operator-- ()                    { i--;  if (!Valid()) i=0;         };
  void operator+= (UWORD a)             { i+=a; if (!Valid()) i=0;         };
  void operator-= (UWORD a)             { i-=a; if (!Valid()) i=0;         };
  void operator+= (LIterIncArg arg)     { if(arg==HALF) i+=(L.Size()-i)/2; };
  void operator-= (LIterIncArg arg)     { if(arg==HALF) i-=i/2;            };
  void Set(LIterSetArg p)
    { switch(p) {
      case FIRST : i=1;          break;
      case MIDDLE: i=L.Size()/2; break;
      case LAST  : i=L.Size();   break; }
    };
  T& operator() () { return L[*this]; };

//  friend class ListBase<T>;
//  friend class List<T>;
//  friend class SortList<T>;
};
#define LIter Iter

template<class T> class sLIter {
 protected:
  const SortList<T>& L;
// public: // eigt. auch protected, klappt aber mit friends nicht so ganz!
  UWORD     i;         // Index im Format 1..N nicht 0..N; 0 heisst ungltig.
 public:
  sLIter(const SortList<T>& l) : L(l), i(1) { if(L.Size()==0) i=0; };
  bool Valid()                            { return (( i<=L.Size()) && i>0); };
  bool ValidFor(const SortList<T>& c)
    { if(&L!=&c) Error(ErrWrongIter); /*else*/ return (&L==&c);            };
  operator bool()                       { return Valid();                  };
  void operator++ ()                    { i++;  if (!Valid()) i=0;         };
  void operator-- ()                    { i--;  if (!Valid()) i=0;         };
  void operator+= (UWORD a)             { i+=a; if (!Valid()) i=0;         };
  void operator-= (UWORD a)             { i-=a; if (!Valid()) i=0;         };
  void operator+= (LIterIncArg arg)     { if(arg==HALF) i+=(L.Size()-i)/2; };
  void operator-= (LIterIncArg arg)     { if(arg==HALF) i-=i/2;            };
  void Set(LIterSetArg p)
    { switch(p) {
      case FIRST : i=1;          break;
      case MIDDLE: i=L.Size()/2; break;
      case LAST  : i=L.Size();   break; }
    };
  T& operator() () { return L[*this]; };
//  friend class SortList<T>;
};


/* ------------------------------------------------------------------------
   List<T>
   Eine List ist ein unsortiertes Array von Elementen. Bitte Bemerkungen
   bei ListBase beachten. Folgende Methoden stehen zustzlich zur Verfgung:
     - Append(T) fgt ein Element an die Liste an
     - Insert(LIter, T) fgt ein Element an best. Stelle ein
*/
template<class T> class List : public ListBase<T>
{ public:
	List(UWORD size = 10, UWORD inc = 5) : (size, inc) {};

    void Append(const T& e)             { ListBase<T>::Append(e);            };
    void Insert(UWORD p, const T& e)    { ListBase<T>::Insert(p, e);         };
    void Insert(LIter<T> p, const T& e) { p.ValidFor(*this); Insert(p.i, e); };

    List& operator+=(const T& a)        { Append(a); return *this;           };

    // Diese Zeilen machen nur die Methoden aus VoidList sichtbar.
    void Remove(UWORD p)                { ListBase<T>::Remove(p);            };
    void Remove(LIter<T> p)             { ListBase<T>::Remove(p);            };
    T& operator[] (UWORD p) const       { return ListBase<T>::operator[] (p);};
    T& operator[] (LIter<T> p)          { return ListBase<T>::operator[] (p);};
// Wieso wird obiger oper nicht von ListBase geerbt???
};


/* ------------------------------------------------------------------------
 = SortList
   Eine sortierte Liste, in der die Elemente automatisch sortiert abgelegt
   sind. Die Elemente mssen die Operator > und = und != und < untersttzen.
   SortList-Objekte bieten folgende Methoden:
        - Add(T) oder +=(T) fgt der Menge ein Element hinzu. Die Position
           kann und soll nicht bestimmt werden; eine Insert()-Methode gibt
           es nicht. Elemente knnen mehrfach vorhanden sein!
        - Find(T) "sucht" ein Element durch Vergleich mit T::operator==
           Find() liefert eine Variable vom Typ LIter zurck.
        - Get(LIter) liefert das zu Iter gehrende Elemente zurck.
        - Remove(LIter) entfernt das zu Iter gehrende Element aus der Menge.

   Listen knnen mit | vereinigt und mit & geschnitten werden.
*/


template<class T> class SortList // : public ListBase<T>
{ protected:
//    UWORD age;      // Zugriffskontrolle fr ?Iter
    List<T> L;

  public:
    SortList(UWORD startSize = 10, UWORD increase = 5)
     : L/*(new ListBase<T>*/(startSize, increase) //, age(0)
     { };
    SortList(const SortList& c)
     : L(c.L)//, age(c.age)
     { };
    operator= (const SortList& c)  { L=c.L; /*age=c.age;*/ };
    //virtual ~SortList()            { };

    void Add(const T& e)
     { LIter<T> I(L); // I(*this);
       bool b=I.Valid();        // Nicht gerade sehr elegant; geht aber nicht
       while(b)                 // anders... Alternative mit while(I && e>L[I]
         if(e>I())              // geht nicht wg. full boolean evaluation.
           { ++I; b=I.Valid(); }
         else
           b=false;
       if(I)
         L.Insert(I,e); // ListBase<T>::Insert(I,e);
       else
         L.Append(e); // ListBase<T>::Append(e);
     };

    SortList& operator+=(const T& a)   { Add(a); return *this; };
/*
    sLIter<T> Find(const T& e)  // mit Intervallhalbierungs-Algorithmus
     { LIter<T> I(*this);
       I.Set(MIDDLE);
       while(I) {
         if(e>L[I])
           I+=HALF;
         else if(e<operator[] (I))
           I-=HALF;
         else                // e==L[I]
           return I;
       };
       return I;             // I not valid!
     };
*/
     T& operator[] (sLIter<T> i)    { return L[i.i]; };
//    void  Remove(sLIter<T> i)      { L.Remove(i); };
};

/* ------------------------------------------------------------------------
// SetBase
   Eine SetBase (Menge) ist eigt. eine sortierte Liste, die jedes Element
   nur einmal enthlt. Sie bietet folgende Methoden:
        - Add(T) oder +=(T) fgt der Menge ein Element hinzu. Wenn schon
           vorhanden, passiert NIX; das ist kein Fehler.
        - Find(T) "sucht" ein Element mittels der Elementmethode
           T::Match(const T&) den alle Elemente zur Verfgung stellen mssen.
           Find() liefert eine Variable vom Typ BIter zurck; der aber nur bis
           zum nchsten Add() oder Remove() Gltigkeit hat.
        - Get(BIter) liefert das zu BIter gehrende Elemente zurck. Su.
        - Remove(BIter) entfernt das zu BIter gehrende Element aus der Menge.
   Die Elemente mssen die Operator > und = und != und < untersttzen.

   Mengen (SetBase) knnen mit | vereinigt und mit & geschnitten werden.
*/

// NOCH NICHT VOLLSTNDIG IMPLEMENTIERT!

/*
template<class T> class Set : public AlObject //, public debugable
{ protected:
    ListBase<T>& L;
    UWORD age;      // Zugriffskontrolle fr BIter

  public:
    void NOT_USABLE() = 0;

    Set(UWORD startSize = 10, UWORD increase = 5)
     : L(*new ListBase(startSize, increase), age(0)
     { };
    Set(const Set& c);
    operator= (const Set& c);
    virtual ~Set() { };

    void Add(const T& e)
     { LIter<T> I(L);
       while(I)         // I heisst I.Valid()
         if(e>L[I])
           I++;
       if(e!=L[I]) {
         if(I)
           L.Insert(I,e);
         else
           L.Append(s4);  };
     };

    T&    Get(BIter i);
    void  Remove(BIter i);

    BIter Find(const T& e)  // Intervallhalbierungs-Algorithmus
     { LIter<T> I(L);
       I.Set(L.Size()/2);

     };
};
*/


/* ------------------------------------------------------------------------ */
//                            IMPLEMENTATION
/* ------------------------------------------------------------------------ */

template<class T> ListTpl<T>::
ListTpl(UWORD startSize, UWORD increase)
  {
    pMemArr=new T[startSize];
    if(!pMemArr)
      Error(ErrNoMoMemory);
    size=startSize; incr=increase; next=0;
   };

template<class T> ListTpl<T>::
~ListTpl()
  { delete[] pMemArr; };

template<class T> ListTpl<T>::
ListTpl(const ListTpl<T>& copyL)
  { size=copyL.size; incr=copyL.incr;
    pMemArr=new T[size];
    for(next=0; next<copyL.next; next++)
      pMemArr[next]=copyL.pMemArr[next];
  };

template<class T>
ListTpl<T>& ListTpl<T>::operator= (const ListTpl<T>& copyL)
  { delete[] pMemArr;
    size=copyL.size; incr=copyL.incr;
    pMemArr=new T[size];
    for(next=0; next<copyL.next; next++)
      pMemArr[next]=copyL.pMemArr[next];
    return *this;
  };

template<class T> void ListTpl<T>::
Append(const T& e)
{ if(next >= size) {
    T* old=pMemArr;
    size+=incr;
    pMemArr=new T[size];
    if(!pMemArr)
      Error(ErrNoMoMemory);
    for(UWORD i=0; i<next; i++)
      pMemArr[i]=old[i];
    delete[] old;
   };

   pMemArr[next++]=e;
};

template<class T> void ListTpl<T>::
Insert(UWORD p, const T& e)
{  if (!( ( (p-1)<next) && p>0 ))
     Error(ErrOORinLA);

   if(next >= size) {
     T* old=pMemArr;
     size+=incr;
     pMemArr=new T[size];
     if(!pMemArr)
       Error(ErrNoMoMemory);

     UWORD i;
     for(i=0; i<(p-1); i++)
       pMemArr[i]=old[i];
     for(i=next; i>(p-1); i--)
       pMemArr[i]=old[i-1];
     delete[] old;
   }
   else {
     for(UWORD i=next; i>(p-1); i--)
       pMemArr[i]=pMemArr[i-1];
     next++;
   };

   pMemArr[p-1]=e;
};

template<class T> void ListTpl<T>::
Remove(UWORD p)
{  if (!( ( (p-1)<next) && p>0 ))
     Error(ErrOORinLA);

   for(UWORD i=(p-1); i<(next-1); i++)
     pMemArr[i]=pMemArr[i+1];

   next--;
};

/* ------------------------------------------------------------------------ */
// LIter - Iterator fr List. Kann mit UWORD initialisiert werden und wird
// nie ungltig.

// typedef class Iter<T> template<class T> class LIter;

/*
enum LIterSetArg { FIRST, MIDDLE, LAST };
enum LIterIncArg { HALF };

template<class T> class LIter : public Iter<T>
{public:
  LIter(const ListBase<T>& l) : Iter<T>(l) { };
  void operator=(UWORD j)               { i=j; if (!Valid()) i=0;          };
  void operator+= (LIterIncArg arg)     { if(arg==HALF) i+=(L.Size()-i)/2; };
  void operator-= (LIterIncArg arg)     { if(arg==HALF) i-=i/2;            };
  void Set(LIterSetArg p)
    { switch(p) {
      case FIRST : i=1;          break;
      case MIDDLE: i=L.Size()/2; break;
      case LAST  : i=L.Size();   break; }
    };

 friend List<T>;
};

template<class T> class sLIter : public Iter<T>
{public:
  sLIter(const ListBase<T>& l) : Iter(l) { };
  sLIter(const LIter<T>& l)    { L=l.L; i=l.i; };
};
*/

/*
class BIter {
  UWORD age;

public:
  bool Valid(); // Ist der Iterator noch gltig?
  operator bool() { return Valid(); };
};
*/

// ============================================================================

/* ------------------------------------------------------------------------ */
// alte Herangehensweise: List enthlt Zeiger auf dyn. Array von Zeigern
//                        auf die Elemente. Problem wg. Freigabe etc.
/*
template<class T> class ListBase : public AlObject //, public debugable
{ protected:
    UWORD size;
	UWORD incr;
	UWORD next;

    // typedef T* TMemArr;
    T** pMemArr;

  public:
	ListBase(UWORD startSize = 10, UWORD increase = 5);
    ListBase(ListBase& copyL);
	virtual ~ListBase();

    void Append(T& e);
    void Insert() {};
    void Remove() {};


// ListBase& operator+= (T& a)	{ Add(a); return *this; };
    T& operator[] (UWORD i)
       { if ((i-1)<next)
           return *pMemArr[i-1];
         else
           Error(ErrOORinLA); };

    BOOL IsA(UWORD id) const { return id==IdList; };
	UWORD TypeOf() const     { return IdList; };
};

template<class T> ListBase<T>::
ListBase(UWORD startSize = 10, UWORD increase = 5)
  {
    pMemArr=new TMemArr[startSize];
    if(!pMemArr)
      Error(ErrNoMoMemory);
    size=startSize; incr=increase; next=0;
   };

template<class T> ListBase<T>::
~ListBase()
 { delete pMemArr; };

template<class T> void ListBase<T>::
Add(T& e)
{ if(next >= size) {
    T** old=pMemArr;
    size+=incr;
    pMemArr=new TMemArr[size];
    if(!pMemArr)
      Error(ErrNoMoMemory);
    for(UWORD i=0; i<next; i++)
      pMemArr[i]=old[i];
    delete old;
   };

   pMemArr[next++]=&e;
};


template<class T> class ListDyn : public ListBase<T>
{ public:
    ~ListDyn()
      { for(UWORD i=0; i<next; i++)
          delete pMemArr[i];        };
    ListDyn(UWORD startSize = 10, UWORD increase = 5)
      : ListBase<T>(startSize, increase) { };
};

*/

/* ------------------------------------------------------------------------ */
/*  ListOS = List of Shells
    Statt Zeigern werden hier echte Shells in einem dynamischen Arrays
    gehalten. Shells belegen nur soviel Platz wie zwei Zeiger.


template<class T> class ListOF : public AlObject //, public debugable
{ protected:
    UWORD size;
	UWORD incr;
	UWORD next;

    // typedef T* TMemArr;
    T** pMemArr;

  public:
	ListBase(UWORD startSize = 10, UWORD increase = 5);
    ListBase(ListBase& copyL);
	virtual ~ListBase();

	// void Add(T& e);
    Insert
    Remove
    Append


//     ListBase& operator+= (T& a)	{ Add(a); return *this; };
    T& operator[] (UWORD i)
       { if ((i-1)<next)
           return *pMemArr[i-1];
         else
           Error(ErrOORinLA); };

    BOOL IsA(UWORD id) const { return id==IdList; };
	UWORD TypeOf() const     { return IdList; };
};
*/
/* ------------------------------------------------------------------------ */
