// PROJECT : ALIB
// FILE    : DEBUG.H - header file for debug facilities
// AUTHOR  : Michael Vorburger, alpha ware, CH-SG
// DATE oC : October 1994
// DATE oLM: October 1994
// LEVEL   : GLE

/* This module makes it possible to detect if memory on the heap was not
   free'd and who new'd it. This can be a great help to find memory problems. */

#define DEBUG


#ifndef __DEBUG_H
#define __DEBUG_H

#if defined(DEBUG)

#include <portab.h>

/*
// TAKE CARE: This header file could be used without linking DEBUG.CPP...
// That's not what we want! This is a way to ensure that debug.cpp was
// linked. Note that we have a new MustLink object in every module that
// imports DEBUG.H...
void ForgotToLinkDebugCPP();
static struct TMustLink { TMustLink() { ForgotToLinkDebugCPP(); }; } MustLink;
*/

void* operator new(size_t s);
void operator delete(void* p);

extern char*    HCnFile;     // argument passing new(T) macro to operator new()
extern unsigned HCnLine;     // dito.

#define alpha_new(T) (HCnFile=__FILE__, HCnLine=__LINE__, new T)

/*template<class T>*/
class debugable /* : virtual public AlObject */ {
  public:
    debugable();
    virtual ~debugable();

  private:
    static UWORD nextnumber;
    UWORD number;
};
// further ideas: Ausgabe von Header mit Name und Startzeit und Endzeile
//                mit Stopzeit und Laufzeit. Ausgabe, wenn unvorgesehenes
//                Ende.

//                Ausgabe des tatschlichen VarNamens und des Typ-Namens
//                IST NUR ber Makros zu lsen; siehe DEBUG.CPP
#else

# define alpha_new(T) (new T)

  class debugable { };

#endif //  defined(DEBUG)

#define new(T) alpha_new(T)

#endif // __DEBUG_H
