// PROJECT : ALIB or rather more - very general
// FILE    : PORTAB.H - some general defines and typedefs
// AUTHOR  : Michael Vorburger, alpha ware
// DATE oC : January 1994
// DATE oLM: October 1994
// LEVEL   : GLE

/* This portab has a nice substite for bools; look at it!
   It has initialization warning, couting with TRUE/FALSE
   and more strict type checking so that it is not compatible
   with int. You'll have to use if( ) and FOR( ) and while( ).

   ...Nice, but inefficient...

   Use alpha bools? If not (undefined) a std enum is supported. */
// #define UseAlBool


#ifndef __PORTAB_H
#define __PORTAB_H

#include <stddef.h>   // size_t

#ifdef UseAlBool
#  include <error.h>  // also includes <iostream.h>
#  include <iostream.h>
#endif

/* MACROS for type casting. These macros don't help very much but by using
   them, it will be easier later to upgrade to the new cast-operators provided
   in the C++ ANSI draft.
*/
#define const_cast(T,e) ((T)e)
// #define const_cast(T,e) const_cast<T>(e) // so umdef. sobald offiz. supp.
#define dynamic_cast(T,r) ((T)r)
// later: dynamic_cast<T>(r)
/* Diesen cast knnte man ev. mal ber IsA()-Methode sicherer machen... */
#define ptr_cast(T,p) ((T*)p)
#define ref_cast(T,r) ((T&)r)
// others (??): static_cast<T>(e) & reinterpret_cast<T>(e)
// typeid(e) [Strous: ptr_type_info(p), ref_type_info(r), static_type_info(T)


/* TC=Type-Cast
   Bitte im Moment IMMER TC frs casten benutzen und NIE mehr (T)e, weil
   so spter die entsprechenden Stellen leichter gefunden werden knnen.
   Es ist gedacht, alle TCs sobald verfgbar durch die neuen cast-Operatoren
   (siehe c't 9/94, S.184ff) zu ersetzten.                                */
#define TC(x,y) ( (y)(x) )

typedef signed long   SLONG;
typedef unsigned long ULONG;
typedef signed int    SWORD;
typedef unsigned int  UWORD;
typedef signed char   SBYTE;
typedef unsigned char UBYTE;


#ifndef NULL
#define NULL    0L
#endif
#define NIL     NULL

#ifdef UseAlBool
class bool {
  enum  internBOOL {internFALSE=0, internTRUE=!0} v; // char v;
  internBOOL init;
  void operator=(int) { }; // Zuweisung int an bool wird wg. private: abgewiesen
  char* AsASCII() const { if (init) return (v ? "TRUE" : "FALSE");
                                   else {Error(ErrNotInitVar); return NULL; };};
public:
  bool(int i);
//    : init(internTRUE)
//    { v=(i!=0    ? internTRUE : internFALSE); };
  bool(void* i);
//    : init(internTRUE)
//    { v=(i!=NULL ? internTRUE : internFALSE); };
  bool();
//    : init(internFALSE)  { };
  bool operator|| (bool c) const; // { return v || c.v; };
  bool operator|| (char c) const; // { return v || c;   };
  bool operator&& (bool c) const; // { return v && c.v; };
  bool operator&& (char c) const; // { return v && c;   };
  bool operator!  ()       const; // { return !v;       };
  char onlyIf(); /*   { if(init) return v;
                             else { Error(ErrNotInitVar); return 0; };
                  };*/
  friend ostream& operator<< (ostream&, const bool&);
  friend bool operator|| (char c1, bool c2);
  friend bool operator&& (char c1, bool c2);
};
#else
  typedef int bool;
  const bool false=0;
  const bool true=!false;
#endif
typedef bool BOOL;

#ifdef UseAlBool
extern bool true;
extern bool false;
inline bool operator|| (char c1, bool c2) { return c1 || c2.v; };
inline bool operator&& (char c1, bool c2) { return c1 && c2.v; };

# define SaveIf(cond)    if(bool(cond).onlyIf() )
# define if(cond)        SaveIf(cond)
# define SaveWhile(cond) while(bool(cond).onlyIf())
# define while(cond)     SaveWhile(cond)
# define FOR(i,t,c)      for(i; bool(t).onlyIf(); c)
#else
# define SaveIf(cond)    if(cond)
# define SaveWhile(cond) while(cond)
# define while(cond)     while(cond)
# define FOR(i,t,c)      for(i; t; c)
#endif

#define TRUE true
#define FALSE false
/*
inline ostream& operator<< ( ostream& s, const bool& o)
  { return s<<o.AsASCII(); };
*/

#endif /* __PORTAB__ */

