// BOOL-TEST

// test program for the BOOL type in alpha lib or later in ANSI C++
// Mike Vorburger, August 1994

/* Problem: Hufig wird bool zB. als #define bool char definiert.
   Das ist SEHR fehlertrchtig, weil dann Memberfunktionen wie
   cl::operator bool() zur berprfungen wie if( cl ) flschlicher-
   weise auch als Castoperatoren verwendet werden, um ein cl in ein
   zB int zu verwandeln.

   Forderung: bool muss ein EIGENER, UNABHNGIGER Typ sein.
              bool kann nicht in char, int usw. konvertiert werden.
              Der Befehl if( cond ) darf als Typ von cond nur bools,
              nicht mehr char/int etc. zulassen.

   Im bool-Typ der alib ist dies weitgehend verwircklicht.
*/

#include <alobject.h>
#include <error.h>
#include <str.h>
#include <math.h>

struct C
{ int i;
  operator bool() { return true; };
  // Das ist gedacht fr berprfungen wie if( cl ) ...
  bool rb() { return true; };
  C& NPow(C& e);
} cl;

struct _INVC : public C
 { } INVC;

int f(int x, int y) { return 7; };

#include <values.h>
//    SWORD b=SWORD(log10(MAXINT) / log10(abs(i)));
C& C::NPow(C& e)
{ if(TRUE)
    if( false )
        { i=pow(i,5); return *this; }
      else
        return cl;
/*    }*/
  else
    { Error(ErrOperUnknownType); return INVC; };
};

//#define HULK C&
//#define SPIDER INVC

#define HULK   int
#define SPIDER 1

HULK test()
{ if(TRUE)
    if(false)
      { cout << "cl is ok." << endl; return 1; }
    else
      return 2;
  else
    { Error(ErrOperUnknownType); return 2; };
};

void main()
{
  int a, b, id=7;
  int* p=NULL;
  C*   ptr_C=&cl;
  bool d='z';    // calls constructor bool(int) not operator= (int)
               // is okay because this constructor is used in every
               // "if".
  bool d2;

  cout << test() << endl;

//a=false; // std:  Kein Fehler! enum nach int ist zulssig!
           // alib: errror: Cannot convert bool to int!
//d=1;     // std:  warning/error: assigning int to bool
           // alib: error: bool::operator=(int) is not accseesible

//cout << d2;   // alib: Laufzeitfehler fr Zugriff auf nicht init-Var!

/**/
  C q; q.i=10;
  cl.i=5;

  C& n=q.NPow(cl);

/**/

  d=false;
  d2=d;

  cout << d2 << endl;
  cout << !d2 << endl;

  d=bool(2>1);  // nur d=(2>1) funktioniert leider nicht!

  d=bool( ptr_C != &cl );  // dito.

// Die logischen Operatoren || und && funktionieren auch; auf bools
// nicht anwendbar sind richtigerweise | & + - *
  cout << (id==7 || cl.rb()) << endl;
// Klammerung nicht vergessen!

  a=10;
  b=5;

//  c=f(a, cl); // cl ist kein int! aber siehe...
                // std:  cl wird ber operator bool() umgewandelt werden!
                // alib: Error Cannot convert 'C' to 'int'

  cout << (1==2) << ' ' << bool(1==2) << endl;
  // nur bool(1==2) liefert die richtige Ausgabe 'FALSE'; 1==2 liefert '0'
}
