/* ------------------------------------------------------------------------ */
/* ------------------------------------------------------------------------ */


//#include <alphalib.h>
#include <list.h>

#include <portab.h>
#include <error.h>
#include <alstring.h>

#include "..\handle\handlecp.h"

#pragma warn -inl

/* ------------------------------------------------------------------------ */

void ContainerDemo(ContainerABC<char,char>& C)
{  C+='a'; C+='b'; C << 'c' << 'd'; cout << "a,b,c,d added." << endl;
   cout << "out comes: " << C() << ' '; cout << C() << endl;

   C << 'e' << 'f'; cout << "e,f added." << endl;

   cout << "out comes: ";
   while(C)
     cout << C() << ' ';
   cout << endl;
};

void Demo1()
{  cout << "Choose: (Q)ueue or (S)tack? ";
   char choice; cin >> choice;
   if(choice=='S')
     { StackT2_E<char,char,Stack_LL<char> > S; // ==> StackTpl<char> S;
       ContainerDemo(S); }
   else
     { QueueTpl<char> Q; ContainerDemo(Q); };
};

/* ------------------------------------------------------------------------ */

void ContainerDemoPtr(ContainerABC<char*,char*>& C)
{  C+=new(char('a'));
   C+=new(char('b'));
   C << new(char('c'))
     << new(char('d')); cout << "a,b,c,d added." << endl;

   char* pc;
   pc=C(); cout << "out comes: " << *pc << ' '; delete pc;
   pc=C(); cout << *pc << endl; delete pc;

   C << new(char('e'))
     << new(char('f')); cout << "e,f added." << endl;

   cout << "out comes: ";
   while(C)
     { pc=C(); cout << *pc << ' '; delete pc; };
   cout << endl;
};

void Demo1Ptr()
{  cout << "Choose: (Q)ueue or (S)tack? ";
   char choice; cin >> choice;
   if(choice=='S')
     { StackP<char*> S;
       ContainerDemoPtr(S); }
   else
     { QueueP<char*> Q; ContainerDemoPtr(Q); };
};

/* ------------------------------------------------------------------------ */

void ContainerDemoHnd(ContainerABC<MyVar,MyVar>& C)
{
   C+='a'; C+=3; C << 'c' << 7; cout << "a,3,c,7 added." << endl;
   cout << "out comes: " << C() << ' '; cout << C() << endl;

   C << 0 << 'f'; cout << "0,f added." << endl;

   cout << "out comes: ";
   while(C)
     cout << C() << ' ';
   cout << endl;
};

void Demo1Hnd()
{  cout << "Choose: (Q)ueue or (S)tack? "; // or (A)rray? ";
   char choice; cin >> choice;
   if(choice=='S')
     { StackH<MyVar> S; ContainerDemoHnd(S); }
   else if(choice=='Q')
     { QueueH<MyVar> Q; ContainerDemoHnd(Q); }
   else
     //{ ArrayTpl<MyVar> A(5); ContainerDemoHnd(A); }
   ;
};

/* ------------------------------------------------------------------------ */

void OCollDemo(OCollectionABC<String,String>& O)
{
  O+="Hallo";
  O+="Welt";
  O+="!";

  cout << O[2] << ' ' << O[1] << endl;

  OIter<String,String> I=O.NewOIter(); // this: AIter<String> I(O); let's the compiler crash
  while (I)
    { cout << O[I] << ' '; ++I; };
  cout << OCollUWI(O) << endl;

  OIter<String,String> OI=O.Find_OIter("Welt");
  if(OI)
  { cout << "Found: " << O[OI] << endl;
    Iter<String,String>  J=OI;
    cout << "Found (J): " << O[J] << endl;
    O.Remove(J);
    cout << "after Remove(J) remains " << OCollUWI(O) << endl;
  };
};

void Demo2()
{
  ArrayTpl<String> A(3);
  OCollDemo(A);

  //ArrayTpl<String> aA(3);  aA=A;
  //cout << OCollUWI(aA) << endl;
};

/* ------------------------------------------------------------------------ */

void Demo3() // Iterator's Assignment and Copy-Cstr
{
  ListTpl<String> L(2);
  L+="Gute";
  L+="Nacht";
  L+="!";
  cout << OCollUWI(L) << endl;

  OIter<String,String> I=L.Find_OIter("!");
  if(I) {
    L.Insert(I,"und schlaf gut");
    L.Insert(1,">>");
    cout << OCollUWI(L) << endl;  };
};

void Demo4() // SortList
{
   SortListTpl<String> SL;

   SL+="A";
   SL+="C";
   cout << OCollUWI(SL) << endl;
   SL+="B"; cout << OCollUWI(SL) << endl;
   SL+="0"; cout << OCollUWI(SL) << endl;
   SL+="Z"; cout << OCollUWI(SL) << endl;
   SL+="F"; cout << OCollUWI(SL) << endl;
   SL.Remove(1); cout << OCollUWI(SL) << endl;
   cout << SL[4] << " weg="; SL.Remove(4); cout << OCollUWI(SL) << endl;

};

/* ------------------------------------------------------------------------ */

int main(void)
{
  Demo4();
  return 0;
};

/* ------------------------------------------------------------------------ */

/*
void DemoIterAssiCopy() // Iterator's Assignment and Copy-Cstr
{
  Array<String> A(3);
  A+="Hallo";
  A+="Welt";

// The following is allowed because it works with concrete types (AIter)
  AIter<String> AI1(A);
  cout << A[AI1] << endl; // Hallo

  ++AI1;
  AIter<String> AI2(AI1);
  cout << A[AI2] << endl; // Welt

  AIter<String> AI3(A);
  cout << A[AI3] << ' ';  // Hallo
  AI3=AI2;
  cout << A[AI3] << endl; // Welt

/* All the following is NOT allowed:
  //OIter<String,String>& OI1=A.NewOIter();
  //OIter<String,String>& OI2=A.NewOIter();

  //OIter<String,String>& OI3(OI1);
  //OI1=OI2;

  //AI3=OI1; AIter<String> AI4(OI2);

  //Iter<String,String>& I1=A.NewIter();
  //AI3=I1; AIter<String> AI5(I1);

  //OI1=I1;
*/
};
*/
