// Handle-Demo
// ===========

#include <alobject.h>

#include "handle.h"

struct NixClass { void Show() { }; } Nix;
#include <conio.h>
#define DOC(stat,X) cout << "$$ "; cout.width(24); cout.setf(ios::left); cout.fill(' '); cout << #stat << ">"; stat gotoxy(50,wherey()); cout << "< "; cout.width(4); cout.fill(' '); cout << #X << "= "; X.Show(); cout << endl;
#define INFO(txt) cout << ":" << txt << endl << endl;
#define PROG(txt) cout << " " << txt << endl;

void Demo1()
{
  cout << "Demo1: Construction, assignment and object-data access" << endl;
  cout << "------------------------------------------------------" << endl;
  cout << "given: class WArrF : public Fruit" << endl;
  cout << "       class WArr  : public Hnd<WArrF>" << endl << endl;;

  DOC(WArr H1(7);,H1)
  DOC(WArr H2(0); ,H2)
  INFO("Two _new_ Fruits were created by using the Handle constructor.")

  DOC(H2=H1;,H2)
  DOC(WArr H3(H2);,H3)
  INFO("Handle-Assignments. FLAT-COPY. Fruit is NOT copied. Old Fruit free'd.")

  DOC(H3->l=-3;,H3)
  DOC(,H2);
  INFO("We changed H3, so a DEEP-Copy was performed. H2 did of course not change.")

  DOC(H3=H2;,H3)
  DOC(cout << H3->l;,H3)
  INFO("Unfortunately, a DEEP-Copy is made too; though FLAT would be enough -:(")

  DOC(const WArr cH1(4);,cH1)
  DOC(const WArr cH2(cH1);,cH2)
  DOC(cout << cH2->l;,cH2)
  INFO("Only const Objects never involve DEEP-Copies; which is great!")
};

void Foo(WArrF arg)         { arg=4; arg.Show(); };
void FooR(WArrF& arg)       { arg=5; arg.Show(); };
void FooC(const WArrF& arg) {        arg.Show(); };

WArr fooFA(const WArrF& a)  { return a; };
WArr fooHA(WArr& a)         { return a; };

void Demo2()
{
  cout << "Demo2: Member function access and function argument" << endl;
  cout << "---------------------------------------------------" << endl;
  cout << "given: class WArrF : public Fruit" << endl;
  cout << "       class WArr  : public Hnd<WArrF>" << endl;
  cout << "       void WArr::ShowConst() const { Frt().PrintThis_Const(); };" <<endl;
  cout << "       void WArr::ShowChange()      { Frt().PrintThisChange(); };" <<endl <<endl;

  DOC(WArr H1(7);,H1)
  DOC(WArr H2(H1);,H2)

  DOC(H1().PrintThisChange();,H1)
  INFO("We called a non-const member of H1() -of WArrF!- & a DEEP-Copy was performed.")

  DOC(H1=H2;,H1)
  DOC(H1().PrintThis_Const();,H1)
  INFO("Unfortunately, another DEEP-Copy was involved though not neccessary :-(")

  DOC(H1=H2;,H1)
  DOC(H1.ShowConst();,H1)
  INFO("Ok. FLAT-Copy because const member of WArr -not -F. Compare to above. (Demo6)")

  DOC(const WArr cH1(4);,cH1)
  DOC(const WArr cH2(cH1);,cH2)
  DOC(cH1().PrintThis_Const();,cH1)
  INFO("Const Objects (Handles) never involve a DEEP-Copy.")
  // DOC(cH1().PrintThisChange();,cH1) // ERR: non-const called for const obj ch2

  cout << "given: void Foo(WArrF arg)          { arg=4; arg.Show(); }; " << endl
       << "       void FooR(WArrF& arg)        { arg=5; arg.Show(); }; " << endl
       << "       void FooC(const& WArrF arg)  {        arg.Show(); }; " << endl;
  DOC(H1=H2;,H2)
  DOC(Foo(H1());,H1)
  DOC(FooR(H1());,H1)
  DOC(,H2)
  INFO("These func-calls work exactly as usual.")

  DOC(H1=H2;,H2)
  DOC(FooC(H1());,H1)
  INFO("I'm sorry: Again, an unneccessary DEEP-Copy is performed. :-(")

  DOC(Foo(cH1());,cH1)
  DOC(FooC(cH1());,cH1)
  INFO("These func-calls with const-args work as usual; consts always FLAT copy.")

  PROG("WArr fooFA(WArrF& a) { return a; };")
/* DOC(H1=H2;,H2)
  DOC(WArr H3=fooFA(H1());,H3)
  DOC(H3.ShowChange();,H3)
  DOC(,H1)
*/
  DOC({ WArr H=7;,H)
  DOC(H=fooFA(2); };,Nix)
  cout << ":Two runtime errors occured. What happened? - The compiler generated a"<<endl;
  cout << ":temporary auto-fruit with constructor WArrF(2) and passed it to fooFA."<<endl;
  cout << ":Afterwards, the auto-fruit was deleted-although H still pointed to it."<<endl;
  cout << ":PS: My alib would produce a fatal error when accessing H like H.Show()." << endl;
  INFO(   "This delete (compiler generated) of auto-fruit cannot be avoided.")

  PROG("fooHA(WArr& a) { return a; };")
  DOC({WArr H=fooHA(2);,H)} // -> Warning: Temporary used for parameter 'a'in fooHA(WArr&)
  cout <<  ":Why don't you declare fooCFA(WArr& a) with a Hnd instead a Fruit"<<endl;
  cout <<  ":as argument? In this case too, a temporary Handle has to be created,"<<endl;
  INFO(     "but that's ok. Auto-HANDLES can be used, but not auto-fruits!")

  cout << ":My Compiler warns that, because the Ref-Param a is not const. If we define"<<endl;
  cout << ":fooHA(const WArr& a) no warning is given but there still a temp.obj. created"<<endl;
  INFO(   "As you see, using const doen't solve the problem in this case.")
};

void Demo3()
{
  cout << "Demo3: comparison and equality." << endl;
  cout << "---------------------------------------------------" << endl;
  cout << "given: class WArrF : public Fruit" << endl;
  cout << "       class WArr  : public Hnd<WArrF>" << endl <<endl;

  DOC(WArr H1(7);,H1)
  DOC(WArr H2(H1);,H2)
  DOC(cout << (H1==H2);,H2)
  INFO("The Handle class realized that H2 is a flat copy of H1. Very quickly!")

  DOC(H2=7;,H2)
  DOC(cout << (H1==H2);,H1)
  cout << ":In this case, an WArrF::operator==(WArrF&) is involved. It has to be" << endl;
  INFO("declared and defined only if comparison (==) is needed for this class.")
};

WArr foo1()              { return 3;             };
WArr foo2(const WArr& a) { return a;             };
WArr foo3()              { return *new WArrF(5); };

void Demo4()
{
  cout << "Demo4: return Handles from funcs." << endl;
  cout << "---------------------------------" << endl;
  cout << "given: class WArrF : public Fruit" << endl;
  cout << "       class WArr  : public Hnd<WArrF>" << endl;
  cout << "       WArr foo1()              { return 3;            };"<<endl;
  cout << "       WArr foo2(const Warr& a) { return a;            };"<<endl;
  cout << "       WArr foo3()              { return new WArrF(5); };"<<endl<<endl;

  DOC(WArr H(7);,H)
  DOC(WArr retH=foo1();,retH)
  DOC(retH=foo2(H);,retH)
  INFO("See, it is possible to return anything from a function.")

  DOC(retH=foo3();,retH)
  cout << ":This has special advantages if the Fruit is an ABC. Standard C++ causes"<<endl;
  cout << ":big troubles in that case: You cannot return the ABC, so you had to"<<endl;
  cout << ":use a reference. But who cares to free the object if it was a created " <<endl;
  cout << ":inside the func, like in foo3() above?" << endl;
  INFO ("--- In this case, Handles are a great solution!")
};

void Demo5()
{
  cout << "Demo5: Const Handles, Const and static Fruits." << endl;
  cout << "----------------------------------------------" << endl;
  cout << "given: class WArrF : public Fruit" << endl;
  cout << "       class WArr  : public Hnd<WArrF>" << endl<<endl;

  DOC(const WArr cH(4);,cH)

  cout << ":Compiler checks (100%) that only non-const operations are used for cH. Things" <<endl;
  INFO("like cH=7; or H1().PrintThisChange(); are caught at compile-time.")

  DOC(const WArrF cF(1);,cF)
  INFO("That's a static Fruit. For theses examples, it's constness is not important.")

  DOC(WArr H=cF;,H)
  DOC(H.ShowChange();,H)
  DOC(,cF)
  INFO("Look, cF was unfortunately changed too :-(")

  DOC(const WArrF _cF(1);,_cF)
  DOC(_cF.MakeStatic();,_cF)
  DOC(H=_cF;,H)
  DOC(H.ShowChange();,H)
  DOC(,_cF)
  cout<< ":Now it's okay. cF remained unchanged. ALWAYS call MakeStatic() for static"<<endl;
  INFO("Fruits or -much better- try to avoid them.")
};


void Demo7()
{
  cout << "Demo7: Dealing with Fruit Ptrs/Refs." << endl;
  cout << "------------------------------------" << endl;
  cout << "given: class WArrF : public Fruit" << endl;
  cout << "       class WArr  : public Hnd<WArrF>" << endl << endl;

  DOC(WArrF* pF=new(WArrF(0));,(*pF))
  DOC(WArr   H=*pF;,H)
  DOC(delete pF;,(*pF))
  INFO("RULE: Never delete a Fruit by yourself!")
  DOC(WArrF* pF2=new(WArrF(9));,(*pF2))
  DOC(,H)
  cout<<":Do you realize what happened?"<<endl;
  cout<<":Try to avoid ptrs oder refs to Fruits in general. Why not using their Hnd?"<<endl;
  cout<<":If you use it nevertheless, use CONST ptrs/refs."<<endl;
  INFO("NEVER use ptrs/refs to Fruits you created!")
};


void Demo6(); // is in HANDLE6.CPP
/*
void main()
{
  Demo6();
}; */