#include <iostream.h>

class VarF : public Fruit
{ public:
    virtual void Print() const = 0; // const
    virtual void Incr()        = 0; // non-const

  friend class MyVar;
};


class IntF : public VarF
{  int i;

 public:
	IntF(int a) : i(a)     {};
	IntF& operator=(int a) { i=a; return *this;   };

	void Print() const     { cout << "int " << i; };
	void Incr()            { i++;                 };

	FRUITMACRO(IntF)

//  friend MyVar;
};

class CharF : public VarF
{  char c;

 public:
			 CharF(char pC)      : c(pC)             { };
	CharF& operator=(char pC)  { c=pC; return *this; };

	void Print() const         { cout << "char " << c; };
	void Incr()                { c++; c&=127; if (c<33) c=33; };

	FRUITMACRO(CharF)

//  friend MyVar;
};

class MyVar : public Hnd<VarF>
{public:
	SHELL_INTF(MyVar,VarF)
	FRUITINIT_INTERFACE_FAM(MyVar,CharF,VarF,char)
	FRUITINIT_INTERFACE_FAM(MyVar,IntF,VarF,int)

	void Print() const     { Frt().Print(); cout << endl; };
   void Incr()            { Frt().Incr();                };
};

