// Demoprogramm I fr alpha-lib.
// January-February 1994, MV


#include <alstream.h>
#include <alobject.h>
#include <ids_test.h>	// unbedingt als letztes!

#include <conio.h>		// fr clrscr()
#include <stdlib.h> 	// fr itoa()

class MyIntClass : public AlObject, public isASCIIable, public isSortable
{
  private:
	SWORD i;
	BOOL  def;	// Wert definiert?

  public:
	MyIntClass()
	  { def = FALSE; };
	MyIntClass(SWORD v)
	  { operator= (v); };
	MyIntClass operator= (SWORD v)
	  { i=v;
		def = TRUE;
		return (*this);
	  };
//	operator int() const	// Cast-Operator
//	  { if ( !def )
//			Error( ErrNonInitVar );
//		return (i);
// 	  };
/*-------------------------------------------------------------------------
  Cast-Operatoren sind fr die Fehlerbehandlung eher ungnstig. Um Rechen-
  operationen mit Integern zu ermglichen, werden besser die betroffenen
  Operatoren neu definiert (umstndlicher), damit z.B. bei einem nicht
  initialisierten Objekt ein Fehler-Objekt zurckgeliefert werden kann.
  Dies wre bei casting jedoch nicht mglich.
 -------------------------------------------------------------------------*/
	MyIntClass operator+ (SWORD a);
	MyIntClass operator+ (MyIntClass a);

	BOOL IsEqual(const isSortable& c)
	  { if( c.IsA(IdAppIntClass) )
			{ return( ((MyIntClass&)c).i == i ); }
		else
			{ Error(ErrNonValidComp); return(0); };
			// return: zu 95% ok - 100% wre Rckgabe eines
			// nichtinitialisierten=nichtdefinierten Bools
	  };
	virtual BOOL IsBigger(const isSortable& c)
	  { return( TRUE ); };

//	BOOL operator== (const MyIntClass& c)
//	  { return( c.i == i ); };

	virtual BOOL IsA(UWORD id) const
		{ return( id==IdAppIntClass
					  || AlObject::IsA(id)
					  || isASCIIable::IsA(id)
					  || isSortable::IsA(id) ); };

	String AsASCII() const
	  {
		char s[18];
		if ( def )
			return( itoa(i, s, 10) );
		else
			{ Error( ErrNonInitVar ); return( StringErr ); };
	  };
} ErrMyIntClass;
// ErrMyIntClass ist ein nicht initialisiertes Objekt, das
// fr return-Codes nach Fehlern verwendet wird.

// Ein Err<Classname> Objekte sollte es fr alle Klassen
// genau einmal (nicht keinmal) geben.


// Diese beiden Methoden mussten ausgelagert werden, weil
// ErrMyIntClass oben noch nicht bekannt ist.
MyIntClass MyIntClass::operator+ (MyIntClass a)
{ if ( def && a.def )
	return (MyIntClass( i + a.i ));
  else
	Error(ErrNonInitVar);
	return (ErrMyIntClass);
}

MyIntClass MyIntClass::operator+ (SWORD a)
{ if ( def )
	return (MyIntClass( i + a ));
  else
	Error(ErrNonInitVar);
	return (ErrMyIntClass);
}

void main()
{
	clrscr(); ErrorSetMode( /*quiet */toCout, deutsch );

	AlObject no;
//	cout << no << endl;	// das lehnt der Compiler (Linker) jetzt ab!

	MyIntClass  MyInt1,
				MyInt2,
				MyInt3=300;		// MyIntClass(300) wird aufgerufen
	AlObject&   MyIntRef=no;
	MyInt1=11;                 	// operator= wird aufgerufen

	cout << MyInt1 << ' ' << MyInt2 << ' ' << MyInt3 << endl;

	cout << MyInt1+7 << endl;	// hierbei wird ein temporres Objekt erzeugt.
	MyInt1 = MyInt2 + 7;		// Zugriff auf nicht initialierte Variable.
	cout << MyInt1 << endl;

//---

	if ( MyInt1 == MyInt3 )
		cout << "MyInt1 == MyInt3." << endl;
	else
		cout << "MyInt1 != MyInt3." << endl;

// gibt eine <Illegal structure operation>, weil AlObject (no) nicht von
// comparable abgeleitet ist. Andere Klassen wrden aber gehen und je nach
// dem einen Runtime-Fehler erzeugen.
//	if ( MyInt1 == no )
//		cout << "Klar, Vergleich ist ja gar nicht mglich!" << endl;

	if ( MyIntRef.IsA( IdAppIntClass ) )
		cout << "MyIntRef zeigt auf MyInt-Objekt." <<endl;
	else
		cout << "MyIntRef zeigt auf allg. AlObject"<<endl;
	&MyIntRef = &MyInt2;
	if ( MyIntRef.IsA( IdAppIntClass ) )
		cout << "MyIntRef zeigt auf MyInt-Objekt."<<endl;
	else
		cout << "MyIntRef zeigt auf allg. AlObject"<<endl;
}