// PROJECT : ALIB (alpha library)
// FILE    : ERROR.CPP - implementation for runtime error function
// AUTHOR  : Michael Vorburger, alpha ware, CH-SG
// DATE oC : January 1994
// DATE oLM: October 1994
// LEVEL   : GLE

/* This File contains a very simple mechanism for runtime error ability.
   The main function is Error(..)
   All this will be replaced somewhen with true exceptions.              */

#include <stdlib.h> // for abort()
#include <conio.h>  // for wherex()
#include <iostream.h>

#include <error.h>

char* ErrMsgDt[ErrLAST] =
{
    "?? kein Fehler aufgetreten",
//  "abstrakte Basisklassen-Methode in abgeleiteter Klasse nicht definiert",
    "Zugriff auf nicht initialisierte Variable (Handle?) ! [FATAL]",
//  "* Vergleich dieser beiden Typen nicht zulssig",
//  "* Standardkonstruktor nicht benutzbar",
    "[ITN] Die Fruit darf jetzt nicht so (direkt) gelscht werden. Auto-Fruit!",
    "[ITN] Fruit::YAF() wurde zu oft aufgerufen",
    "[ITN] Shell greifft auf tote (freigegebene,zerstrte) Fruit zu! [FATAL]",
//  "\"Frucht\" dieser AlShell kann nicht in gewnschten Typ umgewandelt werden",
    "Array-Grenzen nicht erlaubt",
    "Array ist voll!",
    "Zugriff auf nicht existierendes Listen-Element",
    "Iterator falsch gebunden",
    "Container ist leer",
    "Stringproblem. Zugriff ausserhalb dieses Strings",
    "TERM: Klassen-Typ unbekannt/neu.",
    "TERM: Methode nicht implementiert",
    "TERM: Nulldivision!",
    "TERM: 0^0 ist undefiniert!",
    "TERM: Operation mit unbekanntem Typ. Eine beteiligte Klasse kennt die andre nicht."
};

char* ErrMsgEgl[ErrLAST] =
{
    "no problem",
//  "pure virtual member function not redefined in derrivation",
    "attempt to access non-initialized variable (handle?) ! [FATAL]",
//  "* classes aren't comparable to eachother",
//  "* don't use this standard constructor",
    "[ITN] fruit should not be deleted now. Check Auto-Fruit problem",
    "[ITN] Fruit::YAF() method was called too often",
    "[ITN] Shell access's dead Fruit! [FATAL]",
//  "this shell-object cannot be converted into that fruit",
    "wrong array bounds",
    "array is full!",
    "out of range in LIST access",
    "iterator not linked to this list",
    "container empty!",
    "string access out of range",

    "TERM: unknown or new class in math operation",
    "TERM: method not implemented",
    "TERM: division by zero!",
    "TERM: 0^0 is undefined!",
    "TERM: one class doesn't know the other. Not implemented now; will come soon."
};

enum ErrorAction { notice, none, breakApp };
ErrorAction ErrWhatReact[ErrLAST] =
{
    notice,
//  breakApp,
    breakApp,   // ErrNotInitVar -> ALWAYS breakApp; don't change!
//  none,
//  none,
    notice,
    notice,
    breakApp,
//  breakApp,
    breakApp,
    breakApp,
    breakApp,
    breakApp,
    breakApp,
    breakApp,

    notice,
    notice,
    notice,
    notice,
    notice
};

ErrorModeEnum ErrorMode=toCout;
ErrorLangEnum ErrorLang=english;
void ErrorSetMode( ErrorModeEnum m, ErrorLangEnum l)
{ ErrorMode=m; ErrorLang=l; }

void Error( ErrorCode nr )
{
  if ( ErrorMode==toCout && ErrWhatReact[nr] != none)
    { if (wherex()>1) cerr << endl;
      cerr << "Err #" << nr << ": "
           << ( ErrorLang==english ? ErrMsgEgl[nr] : ErrMsgDt[nr] ) << endl;
    };
    if ( ErrWhatReact[nr] == breakApp )
      { cerr << "App aborted because of breakApp (fatal) error! "; abort(); };
};

// Globale Fehler-Objekte (als Returnwert bei troubles)
// String StringErr = "<String invalid>";
