// PROJECT : ALIB
// FILE    : PORTAB.CPP - implementation of some PORTABle stuff
// AUTHOR  : Michael Vorburger, alpha ware
// DATE oC : August 1994
// DATE oLM: August 1994
// LEVEL   : GLE

#include <portab.h>

#ifdef UseAlBool
 // see the definition of class bool in PORTAB.H and the BOOL.CPP sample code
 bool false(0);
 bool true(1);

/* Das ganze Gebastel hier knnte wesentlich eleganter gelst werden, wenn man
   einfach die Vergleichsoperatoren == > < berladen knnte. Leider wird
     bool operator==(int, int)
   mit der Fehlermeldung
     operator== must be a member function or have a parameter of class type
   abgelehnt. Schade!
*/
/*
  bool(int i)
    : init(internTRUE)
    { v=(i!=0    ? internTRUE : internFALSE); };
  bool(void* i)
    : init(internTRUE)
    { v=(i!=NULL ? internTRUE : internFALSE); };
  bool()
    : init(internFALSE)
    { };
  bool operator|| (bool c) { return v || c.v; };
  bool operator|| (char c) { return v || c;   };
  bool operator&& (bool c) { return v && c.v; };
  bool operator&& (char c) { return v && c;   };
  bool operator!  ()       { return !v;       };
  char onlyIf()   { if(init) return v;
                             else { Error(ErrNotInitVar); return 0; };
                  };
*/
/*inline*/ bool::bool(int i) : init(internTRUE)
  { v=(i!=0    ? internTRUE : internFALSE); };

bool::bool(void* i)
    : init(internTRUE)
    { v=(i!=NULL ? internTRUE : internFALSE); };

bool::bool() : init(internFALSE) {};

bool bool::operator|| (bool c) const { return v || c.v; };
bool bool::operator|| (char c) const { return v || c;   };
bool bool::operator&& (bool c) const { return v && c.v; };
bool bool::operator&& (char c) const { return v && c;   };
bool bool::operator!  ()       const { return !v;       };
#undef if // ACHTUNG Endlosschleife!
#undef while
char bool::onlyIf()   { if(init) return v;
                             else { Error(ErrNotInitVar); return 0; }; };
#define if(cond) SaveIf(cond)
#define while(cond) SaveWhile(cond)

ostream& operator << ( ostream& s, const bool& o)
  { return s<<o.AsASCII(); };

#endif // UseAlBool
