/* COMMENT: This file shows a "mistake" in C++ - at least in my eyes...

            Consider having two classes, one (D) derived from the other (P)
            I want to have the delete operator of class D private so that it
            can not be deleted from outside. No problem, isn't it?

            Well, it IS a problem: The behaviour changes, depending if you have
            destructors in D or P and wheter they are protected or not:

               1. neither P nor D have dstcr -> op D::del is not accessible
               2. D has a protected: dstcr   -> dito.
               3. D has a public: dstcr      -> No Error! D::del IS accessible!
                 In this case, a delete command invokes the public dstcr. It
                 is then this dstcr (member) who invokes the protected op del;
                 but from his point of view, it is not protected anymore....
               4. D has no dstr, but P has   -> No Error!
                 No matter if P's dstctr is protected or public, a default
                 dstrct fpr D is generated; a public one... See 3. for the rest.

   REMARK:  I expected operator new and cstrs to work (rather miss-work) the
            way. But NO, they work as "normally" : If class P has a protected
            operator new, you cannot create (new) such an object dynamically
            from "outside" - no matter what constructor D or P have.

   QUESTION: Why do operator delete/destructors and operator new/constructors
             differ in this behaviour?
*/

#include <iostream.h>

class P
{
 public:
   P() {};
};


class D : public P
{public:
   D() {};

 private:
   void* operator new(unsigned size); //  { return 0L; }; // ::new char[size]; };

//   void operator delete(void* p)
//     { cout << "D::operator delete() invoked!";
//       ::delete p;                                  };
};

int main()
{
  D*     pD=new D;
  delete pD;

  return 0;
};
