typedef unsigned int UWORD;

template<class I, class O> class Iter
{ public:
    virtual const O& Get() const                     = 0;
};

template<class I, class O> class Collection
{ public:
   virtual const O&    Get(const UWORD) const        = 0;
   virtual Iter<I, O>& Find(const I&) const          = 0;
};

template<class T> class ArrayImpl1 : public Collection<T,T>
{ public:
   const T&  Get(const UWORD i) const {  };
   AIterImpl1<T>& Find_AIterImpl1(const T&) const
     { return *new AIterImpl1<T>(*this); };
   Iter<T,T>& Find(const T& i) const
     { return (Iter<T,T>&)Find_AIterImpl1(i); }; // TC
};
// typedef class ArrayImpl1<T> template<class T> Array;
#define Array ArrayImpl1         

template<class T> class AIterImpl1 : public Iter<T,T>
{ public:
    AIterImpl1(const Array<T>& c)          : C(c) { i=1; };
    AIterImpl1& operator=(const AIterImpl1& s)    { i=s.i; return *this; };
    const T& Get() const                          { return C.Get(i); };
  protected:
    const Array<T>& C;
    UWORD i;
};
#define AIter AIterImpl1

int main()
{
   Array<char> A;

   AIter<char> I = A.Find_AIterImpl1('A');
   I=A.Find_AIterImpl1('A');

   Iter<char,char>* J;   J=&I;
   char c=I.Get();

   return 0;
};