// Caspers-BUCH S. 154

// ZUM PROBLEM: Siehe Konstruktor von ListBase

class Base {
  int i;
public:
  Base(int j) { i=j; };
};

class Derived : private Base {
  char* s;
public:
  Derived(char* t, int j) : Base(j)
    { s=t; };
};

// my sample
#include <portab.h>

template<class T> class ListTpl // : public AlObject //, public debugable
{ protected:
    UWORD size;
	UWORD incr;
	UWORD next;

    T* pMemArr;

  public:
	ListTpl(UWORD startSize, UWORD increase);
    ListTpl(const ListTpl& copyL);
    ListTpl& operator= (const ListTpl& copyL);
	~ListTpl();

    void      Append(const T&);
    void      Insert(UWORD, const T&);
    void      Remove(UWORD);

    UWORD     Size() const                  { return next;                      };
};

/* ------------------------------------------------------------------------ */
// ListVoid
typedef ListTpl<void*> ListVoid;

/* ------------------------------------------------------------------------ */
// ListBase<T>
// Eine ListBase ist die Vaterklasse aller Listen, Mengen etc.
// Sie enthlt ein dyn. Array von Elementen und ist nur fr elementare Typen
// mit trivialer oder automatischer Speicherverwaltung geeignet, da Elemente
// unter Umstnden umkopiert werden. Unbedingt mglichst kleine Typen whlen.
// ACHTUNG: Nie Listen von Zeigern verwenden; dazu sind Shells zu verwenden!

/* Folgende Methoden stehen ALLEN Listen, Mengen etc. offen:
     - Size()            gibt die Anzahl der Elemente zurck
     - Remove(Iter)      entfernt ein best. Element
     - T& operator[Iter] gibt ein best. Element zurck                      */

template<class T> class ListBase : private ListVoid
{ public:
	ListBase(UWORD size = 10, UWORD inc = 5) : ListVoid(size, inc) { };
// PROBLEM: typedef nicht richtig interpetiert: ListVoid is not a base class..
// LSUNG:  ListBase(UWORD size = 10, UWORD inc = 5) : ListTpl<void*>(size, inc) { };
// den alten Typ (nicht typedef) angeben wie hier.... ^^^^^^^^^^^^^^^^
//    ListBase(const ListBase& copyL)          { ListVoid::ListVoid(copyL);  };
    ListBase& operator= (const ListBase& c)
     { return (ListBase&)ListVoid::operator=(c); };

    UWORD Size() const       { return ListVoid::Size();                  };
};


ListBase<char> L;
