// PROGRAM AND DESCRIPTION
// Dies ist ein Testprogramm zum ben von Termauswertungen. Es wertet
// Ausdrcke wie '(6+12)/3/(3-1*1)' (gibt 3) aus. Arbeitet mit Rekursion.

// erweiterte Version: Der Parser arbeitet nur noch rekursiv, wenn ntig,
// d.h. Ausdrck gleicher Prioritt werden iterativ abgearbeitet. Es gelten
// folgende Syntaxregeln: ok ist z.B. 5+-9 oder auch 5++4; nicht aber 5---9
// (mit drei Minusen), oder 5+*2 usw.
// Neu wird mit doubles gerechnet (2.5e3) und auch Potenzen untersttzt.

// AUTHOR AND DATE
// Michael Vorburger, September '93 - January '94

// ACHTUNG - FEHLER: z.B. (1+5)/5 = 1+5/5 = 2 (???)  usw.
//					 z.B. 2*(1+1) = 2*2   = 4 (OK!) stimmt aber ??

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define BOOL  int
#define FALSE 0
#define TRUE  !FALSE

#define BASETYPE  double
#define MAXLENBEZ 20 	// Maximale Lnge von Bezeichern (hier: Zahlen)

char 	term[80];
int 	nPosTerm;       // Leseposition in term[]
char     szNumber[MAXLENBEZ];	      // Hilfsspeicher zur Umwandlung String -> Zahl
int	     nPosNumber   = 0;			  // Position im Hilfsspeicher
int		bras;			// Klammerebenen
int		ErrorCode;		// Fehler? Wenn >0, dann steht in ErrorPos die Problemstelle.
int		ErrorPos;		// siehe ErrorCode. Wenn =0, dann Fehler nicht genau eingrenzbar.
						//	(bei Nulldivision liegt der Fehler davor, sonst danach)
char	*ErrorText[] =	// Fehlertexte
		{"",
		 "Syntax-Problem: Unbekanntes Zeichen.",
		 "Schliessende Klammer nocht nicht erwartet.",
		 "Schliessende- ohne ffnende Klammer gefunden.",
		 "Zuviel offene Klammern.",
		 "Nulldivision!",
		 "Kein Operator erwartet."
		};

typedef enum { ROOT, PLUSMINUS, MULTIDIVIDE, POWER } PRIORITY; // ROOT < PLUSMINUS < MULTIDIVIDE < POWER
// typedef enum { SEARCH_NUMBER, SEARCH_OP } MODE;

#define ConvNumberToR \
{ szNumber[nPosNumber] = 0; \
  r = /* atoi */ atof( szNumber ); \
  rUndefined = FALSE; \
  nPosNumber = 0; }

#define NeiNei( nr ) \
{	ErrorCode = nr; ErrorPos = nPosTerm; fCont = FALSE; }

BASETYPE evaluate(PRIORITY priority)
{
//	static int nPosTerm = 0;	// kann von aussen nicht mehr zurckgesetzt werden

	BOOL     fCont        = TRUE;
	BASETYPE r;	    	  				  // Zwischenresultat
	BOOL	 rUndefined   = TRUE;		  // ist r definiert (rUdef != r==0)
	BASETYPE d;					          // Hilfsvariable fr Test auf Nulldivision
//	MODE     mode         = SEARCH_NUMBER;
	PRIORITY nextPriority;				  // Prioritt der folgenden Operation


	while ( fCont && !ErrorCode )
	{
		switch ( term[nPosTerm] ) {
			case '0' :
			case '1' :
			case '2' :
			case '3' :
			case '4' :
			case '5' :
			case '6' :
			case '7' :
			case '8' :
			case '9' :
			case '.' :
			case 'e' :
					   szNumber[nPosNumber++] = term[nPosTerm++];
					   break;
			case '-' : if ( nPosNumber==0 && rUndefined ) // - als Prfix
						{ szNumber[nPosNumber++] = term[nPosTerm++];	break; };
			case '+' : if ( nPosNumber==0 && rUndefined ) // + als Prfix
						{ nPosTerm++; break; };

			case '*' :
			case '/' :   // +/-/* als Operatoren
			case '^' :
					   if ( ( nPosNumber > 1 ) || ( nPosNumber == 1 && szNumber[0] != '-' ) ) {
						   ConvNumberToR;
						   // mode = SEARCH_OP;
					   }
					   else if ( rUndefined ) {
						   NeiNei(6);
					   }
					   switch ( term[nPosTerm] ) {
						  case '+' :
						  case '-' : nextPriority = PLUSMINUS; break;
						  case '*' :
						  case '/' : nextPriority = MULTIDIVIDE; break;
						  case '^' : nextPriority = POWER; break;
						  // case  0  : fCont = FALSE;
					   }

					   if ( nextPriority > priority ) {
						   switch ( term[nPosTerm++] ) {
							   case '+' : r += evaluate( nextPriority ); break;
							   case '-' : r -= evaluate( nextPriority ); break;
							   case '*' : r *= evaluate( nextPriority ); break;
							   case '/' : d = evaluate( nextPriority );
										  if ( d > 0 )
											r /= d;
										  else
											NeiNei(5);
										  break;
							   case '^' : r = pow( r, evaluate( nextPriority ) ); break;
							   case  0  : fCont = FALSE;
						   }
//						   mode = SEARCH_NUMBER;
					   }
					   else
						   fCont = FALSE;
					   break;
			case '(' : nPosTerm++; bras++; r = evaluate( ROOT /*PLUSMINUS*/ ); rUndefined = FALSE; fCont = FALSE; break;
			case ')' : if ( bras ) { bras--;
									 if ( nPosNumber ) { ConvNumberToR; }
									 else 			     NeiNei(2);
								   }
					   else { NeiNei(3) }
					   nPosTerm++;
			case ' ' : nPosNumber++; break;
			case  0  : if ( nPosNumber ) { ConvNumberToR }
					   fCont = FALSE; break;
			default  : NeiNei(1); nPosTerm++;

		};  // select case
	};		// while

	return( r );
};


BASETYPE calc()
{
	BASETYPE result;

	nPosTerm = 0; bras = 0;
	ErrorCode = 0; ErrorPos = 0;

	result = evaluate( ROOT );
	if ( bras > 0 )
		ErrorCode = 4;

	return ( result );
}

void main()
{
	char 		szResultString[20];
	BASETYPE    Result;

	do {                 
		puts("\nGeben Sie einen Term ein: ");
		gets( term );

		if ( term[0] ) {
			puts("Ergebnis: ");
			Result = calc();
			if ( !ErrorCode )
			{
				gcvt( Result, 15, szResultString );
				// szResultString = fcvt(Result, MAXLENBEZ, dummy, dummy); // speziell
				// itoa(Result, szResultString, 10);	// fr int
				puts( szResultString );
			}
			else
			{
				puts("ERROR:");
				puts( ErrorText[ ErrorCode ] );
				if ( ErrorPos && term[ErrorPos] )
				{	puts("Ungefhre Probelemstelle: "); puts( &term[ErrorPos] ); }
			}
		}
	} while ( term[0] );
};