// PROJECT : TERM
// FILE    : main implementation!
// AUTHOR  : Michael Vorburger, alpha ware
// DATE oC : February/July 1994
// DATE oLM: August 1994

//#include <alobject.h>
//#include <error.h>
/* #include <str.h> */
// #include "ids_term.h"    // must be last #include

#include <stdlib.h>         // fr itoa() for abs Macro
#include <math.h>           // for pow() function
#include <values.h>         // for MAXINT


#include "term.h"

/* -------------------------------------------------------------------*/
// IMPLEMENTATION
// ==============
//    GENERAL
// --------------

DEF_FRUITINIT_INTERFACE_FAM(hTerm,Integer,TermABC, SWORD)
DEF_FRUITINIT_INTERFACE_FAM(hTerm,Real,TermABC, double)
DEF_FRUITINIT_INTERFACE_FAM(hTerm,Variable,TermABC,String)

DEF_DERRSH_FRTINI_INTF_FAM(Term,hTerm,Integer,TermABC,SWORD)
DEF_DERRSH_FRTINI_INTF_FAM(Term,hTerm,Real,TermABC,double)
DEF_DERRSH_FRTINI_INTF_FAM(Term,hTerm,Variable,TermABC,String)

//Shell<TermABC>& hTerm::operator=(const SWORD arg) { return EqualFrtPtr(new Integer(arg)); };

// hufig bentigte Konstanten
const Integer Integer_1(-1);
const Integer Integer1(1);
const Integer Integer0(0);

Term Term::operator- (const hTerm& t) const { return( operator+ ( t.Multiply(Integer_1) ) ); };
Term Term::operator/ (const hTerm& t) const { return( operator* ( t.Power(Integer_1) ) ); };
/*
hTerm hTerm::operator- (const hTerm& t) const { return( operator+ ( t*Integer_1 ) ); };
hTerm hTerm::operator/ (const hTerm& t) const { return( operator* ( t^Integer_1 ) ); };
*/

// spezielle Rckgabewerte zum Anzeigen...
T_NoTermF  NoTerm;   // dass _keine_ Vor-Verarbeitung stattfand
T_ErrTermF ErrTerm; // dass ein Fehler auftrat; return nach Error()

//hTerm TermABC::ReCalc(TermABC& t, CalcType how) const { return NoTerm; };
//hTerm Term::Numeric(Numerical& N) const  { return Frt().ReCalc(N,num); };

hTerm TermABC::Numeric(Numerical& N) const  {  return *this; };

void Integer::Set(const Real& R)    { i=SWORD(R);     };
void Real   ::Set(const Integer& I) { d=I;            };

/*
hTerm Term::Numeric(Numerical& N) const
  { hTerm kN=N;
    hTerm rN=Frt().Numeric(N);
    N=kN; return rN;                };
*/

struct T_InitConst {
  T_InitConst()  { Integer_1.MakeStatic(); Integer1.MakeStatic();
                   Integer0.MakeStatic(); NoTerm.MakeStatic();
                   ErrTerm.MakeStatic();                           };
} InitConst;

/* -------------------------------------------------------------------*/
//  documentation of math rules
// =============================
//
//   [g]  = general (_really_ general: number, variable, matrix, summand..)
//   [Num]= Numerical (like Integer, Real, Complex, VLN etc.

/* -------------------------------------------------------------------*/
//     Power
// ==============

hTerm TermABC::Power(const TermABC& x, CalcType how) const
// g^Num(1)=g                    // [if g NOT num]
//                               // if num==0 returns 1
//                               // if num==1 returns g
{ if (how==sym)
    return *new PowerClass(*this, x);
  else {
    if (x.IsA(IdNumerical) )  //&& !IsA(IdNumerical) )
      { //if(TC(x,Numerical&).IsZero() ) // g^0 = 1;
        //  return Integer1;
        if(TC(x,Numerical&).IsOne() )  // g^1 = b;
          return *this;
      };
    return NoTerm;                     // "Normalfall"
  };
};

hTerm Numerical::Power(const TermABC& x, CalcType how) const
//                        // NO: Num(0)^g[!Num] = 0
// Num(0)^Num(<0) = Err
// Num(0)^Num(0)  = Err
// Num(0)^Num(>0) = 0
// Num(1)^g       = 1
{ { const hTerm t=TermABC::Power(x,how); if(t) return t; }
  if(IsZero() )
    //if(!x.IsA(IdNumerical) ) // 0^x fr alle nicht numerischen x = 0
    //  return Integer0;
    if(x.IsA(IdNumerical) ) { //else {
      if(TC(x,Numerical&).IsNegative() )  // 0^(-n) = Err (later: infinity)
        { Error(ErrDivByZero); return ErrTerm; }
      if(TC(x,Numerical&).IsZero() )      // 0^0    = Err
        { Error(Err0Power0);   return ErrTerm; }
      return Integer0;                    // else is positive, return 0
    };
  if(IsOne() )
    return Integer1;
  return NoTerm;                          // "Normalfall"
};

hTerm Integer::Power(const TermABC& x, CalcType how) const
// int^int = numRes if possible, in case of overflow symb
// int^g   = sym
{ { const hTerm t=Numerical::Power(x,how); if(t) return t; }
  if(x.IsA(IdInteger) )
    { if(TC(x,Integer&).IsNegative())
        //if(how==num) { return *new Integer(?); }
        /*else*/ return *new PowerClass(*this, x);
      else {
        if( TC(x,Integer&).i <= SWORD(log10(MAXINT) / log10(abs(i))) )
          { return *new Integer(pow(i,TC(x,Integer&).i));       }
        else
          return *new PowerClass(*this, x);                     };
      }
  else
    {// Error(ErrOperUnknownType); return ErrTerm;            };
        return *new PowerClass(*this, x);                     };
       // Wenn ALIB mal voll dyn.Typumwandlung untersttzt, knnte *this
       // in ein Objekt von Typ von x umgewandelt und das pow() darauf an-
       // gewendet werden. Ungefhr so:
       // Numerical& temp = CreateObject( TypeOf(x) );
       // temp(*this); // init new object of type of x with "myself"
       // temp.NPow(x);
       // return temp;
};

hTerm Real::Power(const TermABC& x, CalcType how) const
// real^num = real^real(num)
// else sym
{ { const hTerm t=Numerical::Power(x,how); if(t) return t; }
  if(x.IsA(IdNumerical) )
    { double e=TC(x,Numerical&); Real& R=*new Real(pow(d,e));
      if (errno) return ErrTerm; else return R;               }
  else
    { return *new PowerClass(*this, x);                       };
};

hTerm Variable::Power(const TermABC& x, CalcType how) const
// v^g = sym
{ { const hTerm t=Operand::Power(x,how); if(t) return t; }
  return *new PowerClass(*this, x);
};

hTerm PowerClass::Power(const TermABC& x, CalcType how) const
// (b^e)^x = b^(e*x)
{ { const hTerm t=Operator::Power(x,how); if(t) return t; }
  return *new PowerClass(b, e.Multiply(x) );
};

hTerm MultiplyClass::Power(const TermABC& x, CalcType how) const
// (a*b*c*...)^x = (a^x)*(b^x)*(c^x)*...
{ { const hTerm t=Operator::Power(x,how); if(t) return t; }
  hTerm M=1; //=*new MultiplyClass(*this);
  OIter<hTerm,hTerm> I=L.NewOIter();
  while (I)
    { M=M.Multiply(L[I].Power(x)); ++I; }
    // BETTER: M.MultiplyThis(L[I].Power ...
  return M;
};

// NOT YET IMPLEMENTED!
hTerm PlusClass::Power(const TermABC& x, CalcType how) const
// (a+b+c+...)^x[Prec] = nach Pascal, sonst sym
{ { const hTerm t=Operator::Power(x,how); if(t) return t; }
  return *new PowerClass(*this, x);
};

/* -------------------------------------------------------------------*/
//    Multiply
// ==============

hTerm TermABC::Multiply(const TermABC& x, CalcType how) const
// g*x[num] : x=0 returns 0, x=1 returns g
{ if(how==sym)
    return *new MultiplyClass(*this, x);
  else {
    if (x.IsA(IdNumerical))
      { if(TC(x,Numerical&).IsZero() ) // g*0 = 0
          return Integer0;
        if(TC(x,Numerical&).IsOne() )  // g*1 = g
          return *this;
      };
    return NoTerm;
  };
};

hTerm Numerical::Multiply(const TermABC& x, CalcType how) const
// num(0)*g = 0, num(1)*g = g
{ { const hTerm t=Operand::Multiply(x,how); if(t) return t; }
  if( IsZero() ) return Integer0; // 0*g = 0;
  if( IsOne() )  return x;        // 1*g = g;
  return NoTerm;
};

hTerm Integer::Multiply(const TermABC& x, CalcType how) const
// int*int          = int or sym (in case of overflow)
// int*g[IdG>IdInt] = g*int
// sonst            = sym
{ { const hTerm t=Numerical::Multiply(x,how); if(t) return t; }
  if (x.IsA(IdInteger))
    if( i > (MAXINT/TC(x,Integer&).i) )        // wenn berlauf...
      return *new MultiplyClass(*this,x);      //   dann symbolisch
    else
      return *new Integer(i*TC(x,Integer&).i); //   sonst numerisch
  else
    if (x.TypeOf() > IdInteger)
       return x.Multiply(*this, how);
    else
       return *new MultiplyClass(*this,x);
};

// NOT YET IMPLEMENTED!
hTerm Real::Multiply(const TermABC& x, CalcType how) const
{ { const hTerm t=Numerical::Multiply(x,how); if(t) return t; }
  return *new MultiplyClass(*this,x);
};

hTerm Variable::Multiply(const TermABC& x, CalcType how) const
// var*var [both ident] = var^2
// var*g[IdG>IdVar]     = g*var
// otherwise            = sym
{ { const hTerm t=Operand::Multiply(x,how); if(t) return t; }
  if(x.IsA(IdVariable))
    if(TC(x,Variable&).id==id)
      return *new PowerClass(*this, *new Integer(2));
  if (x.TypeOf() > IdInteger)
    return x.Multiply(*this, how);

  return *new MultiplyClass(*this, x);
};

hTerm MultiplyClass::Multiply(const TermABC& x, CalcType how) const
// (f1*f2*f3)*x =
{ { const hTerm t=Operator::Multiply(x,how); if(t) return t; }
  return *new MultiplyClass(*this, x); // ## ?? ##
};

hTerm PlusClass::Multiply(const TermABC& x, CalcType how) const
{ { const hTerm t=Operator::Multiply(x,how); if(t) return t; }
  return *new MultiplyClass(*this, x);
};

// NOT YET IMPLEMENTED!
hTerm PowerClass::Multiply(const TermABC& x, CalcType how) const
// (b^e)*x [b==x] = b^(e+1)
// else:          = x*(b^e) ???
// ??? be concerned about IdX ><? IdPower!
{ { const hTerm t=Operator::Multiply(x,how); if(t) return t; }
//  Add(x);
  return *new MultiplyClass(*this, x);
};

/* -------------------------------------------------------------------*/
//      Plus
// ==============

hTerm TermABC::Plus(const TermABC& x, CalcType how) const
// g+x[num] : x=0 return g, otherwise NoTerm
{ if (how==sym)
    return *new PlusClass(*this, x);
  else
    if (x.IsA(IdNumerical))
      if(TC(x,Numerical&).IsZero() )
        return *this;
    return NoTerm;
};

hTerm Numerical::Plus(const TermABC& x, CalcType how) const
// num(0)+g=g;
{ { const hTerm t=Operand::Plus(x,how); if(t) return t; }
  if( IsZero() ) return x;
  return NoTerm;
};

// ACHTUNG: berlauf wird noch nicht abgefangen!
hTerm Integer::Plus(const TermABC& x, CalcType how) const
// int+int          = int
// int+g[IdG>IdInt] = g*int
// sonst            = sym
{ { const hTerm t=Numerical::Plus(x,how); if(t) return t; }
  if(x.IsA(IdInteger) )
    return *new Integer(i+TC(x,Integer&).i);
  else
    if (x.TypeOf() > IdInteger)
       return x.Plus(*this, how);
    else
       return *new PlusClass(*this,x);
};

// NOT YET IMPLEMENTED!
hTerm Real::Plus(const TermABC& x, CalcType how) const
{ { const hTerm t=Numerical::Plus(x,how); if(t) return t; }
  return *new PlusClass(*this,x);
};

hTerm Variable::Plus(const TermABC& x, CalcType how) const
// var+var [both ident] = 2*var
// var+g[IdG>IdVar]     = g+var
// otherwise            = sym
{ { const hTerm t=Operand::Plus(x,how); if(t) return t; }
  if(x.IsA(IdVariable))
    if(TC(x,Variable&).id==id)
      return *new MultiplyClass(*new Integer(2), *this);
  if (x.TypeOf() > IdInteger)
    return x.Plus(*this, how);
  return *new PlusClass(*this, x);
};

hTerm PlusClass::Plus(const TermABC& x, CalcType how) const
{ { const hTerm t=Operator::Plus(x,how); if(t) return t; }
  return *new PlusClass(*this, x);
};

hTerm MultiplyClass::Plus(const TermABC& x, CalcType how) const
{ { const hTerm t=Operator::Plus(x,how); if(t) return t; }
  return *new PlusClass(*this, x);
};

hTerm PowerClass::Plus(const TermABC& x, CalcType how) const
{ { const hTerm t=Operator::Plus(x,how); if(t) return t; }
  return *new PlusClass(*this, x);
};

/* -------------------------------------------------------------------*/
//     AsASCII
// ==============

String MultiplyClass::AsASCII() const
{ String s("(");
  OIter<hTerm,hTerm> I=L.NewOIter();
  while (I)
      { s+=L[I].AsASCII(); ++I; if(I) s+="*"; }
  s+=")";
  return s;
};

/* -------------------------------------------------------------------*/
/*
nchste Schritte: Order-Methode einbauen bzw. ber Sortable realisieren.
Zum Beispiel: Integer(27) > Integer(13) usw.
              Variable("a") > Variable("z") usw.
              1+2 == 1+2
dann: 1. + und * gemss obigen Vergleichen implementieren; beachte Fall ==
         dh: x+x=2x; x*x=x^2;
      2. wahrscheinlich braucht's ein find() o. fr die folgende Flle:
            a+b+c +  b  ->  a+2b+c

              +
             + c  +  b  ->
            a b
      3. usw.

*/
